<?xml version="1.0" encoding="UTF-8"?>
<!--
Crane-gc2ublndr-obfuscated.xsl

This is a stylesheet to generate the validation artefacts (XSD schemas and
CVA assertions) described by a document described by a CCTS model expressed
using genericode. The version of NDR implemented by these stylesheets is
found at:

  http://docs.oasis-open.org/ubl/UBL-NDR/v3.0/UBL-NDR-v3.0.html

For best results the Crane-gcublndrcheck-obfuscated.xsl stylesheet should be
used to analyze the genericode file expressing the CCTS model.  Doing so will
highlight changes to make to prevent certain nonsensical results when
generating the artefacts.

Please see "CreatingExtensionsWithUBLNDR.html" for an illustration of using
these stylesheets

Copyright (C) - Crane Softwrights Ltd. 
              - http://www.CraneSoftwrights.com/links/training-gctk.htm

Portions copyright (C) - OASIS Open 2015. All Rights Reserved.
                       - http://www.oasis-open.org/who/intellectualproperty.php

This documentation and the URI resolution of the XSLT processor both presume
the use of the free Saxon9HE XSLT processor from http://saxon.sf.net ... if
that XSLT 2.0 processor is not being used, then the results may not be as
expected.

Typical invocation:

  java -jar saxon9he.jar {arguments}

Mandatory invocation arguments (URIs are relative to input genericode file):

 - stylesheet file:                         -xsl:Crane-gc2ublndr-obfuscated.xsl
 - input genericode file                    -s:{filename}
 - placebo output in target directory       -o:{dir}/junk.out
 - configuration detail file                config-uri={filename}
 - indication to create CVA for QDT         qdt-as-cva={yes/no}

Optional invocation arguments:

 - only minimum subset of all models        subset-result={yes/no}
 - a particular subset of some models       subset-model-regex={string}
 - a particular subset of some constructs   subset-column-name={string}

Optional invocation arguments (URIs are relative to input genericode file):
(only used when creating extensions or additional documents)

 - config file for base vocabulary          base-config-uri={filename}
 - genericode file for base vocabulary      base-gc-uri={filename}

Necessary invocation argument when the common library has exactly one ABIE:

 - specify the model name          common-library-singleton-model-name={string}

Example invocations:

To create the UBL 2.1 base vocabulary artefacts:

    java -jar ../saxon9he/saxon9he.jar -s:mod/UBL-Entities-2.1.gc
         -xsl:../Crane-gc2ublndr-obfuscated.xsl
         -o:junk.out
         config-uri=../config-ubl-2.1.xml 
         qdt-as-cva=yes

To create the Signature Extension for UBL 2.1:

    java -jar ../saxon9he/saxon9he.jar -s:mod/UBL-Signature-Entities-2.1.gc
         -xsl:../Crane-gc2ublndr-obfuscated.xsl 
         -o:junk.out
         config-uri=../config-ubl-2.1-ext.xml
         base-gc-uri=UBL-Entities-2.1.gc
         base-config-uri=../config-ubl-2.1.xml 
         qdt-as-cva=yes
         common-library-singleton-model-name=UBL-SignatureLibrary-2.1

To create a user extension for UBL 2.1:

    java -jar ../saxon9he.jar -s:mod/MyTimesheetExtension-Entities.gc
         -xsl:../Crane-gc2ublndr-obfuscated.xsl 
         -o:junk.out
         config-uri=../config-myext.xml
         base-gc-uri=UBL-Entities-2.1.gc
         base-config-uri=../config-ubl-2.1.xml
         qdt-as-cva=yes

To create an additional document that uses the UBL 2.1 library:

    java -jar ../saxon9he/saxon9he.jar -s:mod/MyRARequestResponse-Entities.gc
         -xsl:../Crane-gc2ublndr-obfuscated.xsl 
         -o:junk.out
         config-uri=../config-rar.xml 
         base-gc-uri=UBL-Entities-2.1.gc 
         base-config-uri=../config-ubl-2.1.xml
         qdt-as-cva=yes

THE AUTHOR MAKES NO REPRESENTATION ABOUT THE SUITABILITY OF THIS CODE FOR ANY
PURPOSE. THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN 
NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

TECHNICAL NOTE:

This stylesheet has been purposely obfuscated and all comments have been
removed.  Please respect our copyright and do not attempt to reverse 
engineer the techniques involved.

Configuration details file:

The configuration file describes all of the directories and files that are created or files that are needed by the files that are created. The file types are indicated using the type= attribute. The files that are created are:

    CVA - created context/value association file
        - there are as many of these entries as CVA files need to be created
        - each CVA file points to a skeleton CVA file in which <Context> 
          elements have invalid NDRDataType= attributes that are each replaced 
          with a valid address= attribute of the union of all BBIE elements, 
          by name using the BBIE namespace prefix, that use the given 
          qualified data type (e.g. NDRDataType="Currency_ Code. Type") 
    SABIE - created supplemental library ABIE schema file
    SBBIE - created supplemental library BBIE schema file
    XABIE - created extension point ABIE schema file
    AABIE - created additional document ABIE schema file
    CABIE - created common library ABIE schema file
    CBBIE - created common library BBIE schema file
    DABIE - created document ABIE schema file
        - there are as many of these DABIE entries as document schemas need to 
          be created
        - when supplemental/extension/additional schema files are being 
          created, and only one set of such schema files can be created in any 
          given execution, the common schema files are not created
        - when the element name is <file>, a single file is created with the 
          given file name
        - when the element name is <files>, all document ABIE files are 
          created using the name and namespace as a substitution pattern where 
          "%n" is replaced with the name of the document ABIE (not the model 
          name)
        - note that the <files> directive will not create a file for a 
          document ABIE for which there is a corresponding <file> directive 

The files that are referenced are:

    QDT - referenced qualified data types file
    UDT - referenced unqualified data types file
    DOC - documentation namespace (no actual file)
    EXT - referenced extension content file (optional)
        - the child of this entry is an XSD reference to the extension point 
          to be included in every document schema as the first child of the 
          document element 

All allowed abbreviations must be itemized as these are the portions of 
element names that do not satisfy the UpperCamelCase convention.  What is not
shown in the example below is that the <abbreviation> element can have an
optional valuesOnly="" or namesOnly="" attribute to indicate that the
abbreviation is not applicable to both values and names.

All equivalences between primary nouns and representation terms must be
itemized.

All fields allowing excess space characters must be named by their genericode
column names.

All mandatory BIEs for each maindoc must be itemized with their cardinality
and, optionally, their order.

All allowed unqualified data types must be itemized to ensure nothing unsupported is asked for.

A common comment can be defined for all files for which a specific comment is not provided. This comment is placed at the start of the file created. There are a number of substitution variables available for this comment:

    %% - a single percent sign
    %f - the output filename (with config path)
    %n - the output module name (no config path)
    %t - the local time of file creation
    %z - the UTC (Zulu) time of file creation

The configuration file is organized by multiple directory parent elements that 
are used to calculate relative URI references for XSD import directives. There 
need not be any directory entries. The directory entry with the attribute 
runtime-name= triggers the recreation of the suite of contained files in the 
given alternative directory, but with XSD documentation constructs removed.

The configuration file used for UBL 2.1 is as follows:

<!DOCTYPE configuration
[
<!ENTITY versionDisplay "2.1 OS">
<!ENTITY versionDirectory   "os-UBL-2.1">
<!ENTITY versionDate        "04 November 2013">
]>
<configuration xmlns:xsd="http://www.w3.org/2001/XMLSchema"
               commonModelSubstring="CommonLibrary"
               version="2.1">
  <!- -
    This is the configuration of the base schema fragments for UBL 2.1
  - ->
  <abbreviations>
    <abbreviation short="CV2">Card Verification Value</abbreviation>
    <abbreviation short="ID">Identifier</abbreviation>
    <abbreviation short="URI">Uniform Resource Identifier</abbreviation>
    <abbreviation short="UNDG">United Nations Development Group</abbreviation>
    <abbreviation short="UBL">Universal Business Language</abbreviation>
    <abbreviation short="UUID">Universally Unique Identifier</abbreviation>
    <abbreviation short="XPath">XML Path Language</abbreviation>
  </abbreviations>
  <equivalences>
    <equivalence>
      <primary-noun>URI</primary-noun>
      <representation-term>Identifier</representation-term>
    </equivalence>
    <equivalence>
      <primary-noun>UUID</primary-noun>
      <representation-term>Identifier</representation-term>
    </equivalence>
  </equivalences>
  <fields-allowing-excess-space>
    <field-name>Definition</field-name>
    <field-name>Examples</field-name>
    <field-name>EditorsNotes</field-name>
  </fields-allowing-excess-space>
  <mandatory-maindoc-BIEs>
    <property-term type="BBIE" cardinality="0..1" order="1"
                                  >UBL Version Identifier</property-term>
    <property-term type="BBIE" cardinality="0..1" order="2"
                                  >Customization Identifier</property-term>
    <property-term type="BBIE" cardinality="0..1" order="3"
                                  >Profile Identifier</property-term>
    <property-term type="BBIE" cardinality="0..1" order="4"
                                  >Profile Execution Identifier</property-term>
    <property-term type="ASBIE" cardinality="0..n"
                                  >Signature</property-term>
  </mandatory-maindoc-BIEs>
  <types>
    <type>Amount</type>
    <type>Binary Object</type>
    <type>Code</type>
    <type>Date Time</type>
    <type>Date</type>
    <type>Graphic</type>t
    <type>Identifier</type>
    <type>Indicator</type>
    <type>Measure</type>
    <type>Name</type>
    <type>Numeric</type>
    <type>Percent</type>
    <type>Picture</type>
    <type>Quantity</type>
    <type>Rate</type>
    <type>Sound</type>
    <type>Text</type>
    <type>Time</type>
    <type>Value</type>
    <type>Video</type>
  </types>
<comment>
  Library:           OASIS Universal Business Language (UBL) &versionDisplay;
                     http://docs.oasis-open.org/ubl/&versionDirectory;/
  Release Date:      &versionDate;
  Module:            %f
  Generated on:      %z
  Copyright (c) OASIS Open 2013. All Rights Reserved.
</comment>
    <copyright position="end">
  OASIS takes no position regarding the validity or scope of any 
  intellectual property or other rights that might be claimed to pertain 
  to the implementation or use of the technology described in this 
  document or the extent to which any license under such rights 
  might or might not be available; neither does it represent that it has 
  made any effort to identify any such rights. Information on OASIS's 
  procedures with respect to rights in OASIS specifications can be 
  found at the OASIS website. Copies of claims of rights made 
  available for publication and any assurances of licenses to be made 
  available, or the result of an attempt made to obtain a general 
  license or permission for the use of such proprietary rights by 
  implementors or users of this specification, can be obtained from 
  the OASIS Executive Director.

  OASIS invites any interested party to bring to its attention any 
  copyrights, patents or patent applications, or other proprietary 
  rights which may cover technology that may be required to 
  implement this specification. Please address the information to the 
  OASIS Executive Director.
  
  This document and translations of it may be copied and furnished to 
  others, and derivative works that comment on or otherwise explain 
  it or assist in its implementation may be prepared, copied, 
  published and distributed, in whole or in part, without restriction of 
  any kind, provided that the above copyright notice and this 
  paragraph are included on all such copies and derivative works. 
  However, this document itself may not be modified in any way, 
  such as by removing the copyright notice or references to OASIS, 
  except as needed for the purpose of developing OASIS 
  specifications, in which case the procedures for copyrights defined 
  in the OASIS Intellectual Property Rights document must be 
  followed, or as required to translate it into languages other than 
  English. 

  The limited permissions granted above are perpetual and will not be 
  revoked by OASIS or its successors or assigns. 

  This document and the information contained herein is provided on 
  an "AS IS" basis and OASIS DISCLAIMS ALL WARRANTIES, 
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO ANY 
  WARRANTY THAT THE USE OF THE INFORMATION HEREIN 
  WILL NOT INFRINGE ANY RIGHTS OR ANY IMPLIED 
  WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A 
  PARTICULAR PURPOSE.    
</copyright>
    <type-documentation>
      <ccts:Component xmlns:ccts="urn:un:unece:uncefact:documentation:2">
         <ccts:ComponentType>ComponentType</ccts:ComponentType>
         <ccts:DictionaryEntryName>DictionaryEntryName</ccts:DictionaryEntryName>
         <ccts:Version>Version</ccts:Version>
         <ccts:Definition>Definition</ccts:Definition>
         <ccts:Cardinality>Cardinality</ccts:Cardinality>
         <ccts:ObjectClassQualifier>ObjectClassQualifier</ccts:ObjectClassQualifier>
         <ccts:ObjectClass>ObjectClass</ccts:ObjectClass>
         <ccts:PropertyTermQualifier>PropertyTermQualifier</ccts:PropertyTermQualifier>
         <ccts:PropertyTerm>PropertyTerm</ccts:PropertyTerm>
         <ccts:AssociatedObjectClass>AssociatedObjectClass</ccts:AssociatedObjectClass>
         <ccts:RepresentationTerm>RepresentationTerm</ccts:RepresentationTerm>
         <ccts:DataTypeQualifier>DataTypeQualifier</ccts:DataTypeQualifier>
         <ccts:DataType>DataType</ccts:DataType>
         <ccts:AlternativeBusinessTerms>AlternativeBusinessTerms</ccts:AlternativeBusinessTerms>
         <ccts:Examples>Examples</ccts:Examples>
      </ccts:Component>
    </type-documentation>
    <dir name="xsd" runtime-name="xsdrt">
      <dir name="common">
        <file type="CABIE" name="UBL-CommonAggregateComponents-2.1.xsd"
              prefix="cac"
namespace="urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2"/>
        <file type="CBBIE" name="UBL-CommonBasicComponents-2.1.xsd"
              prefix="cbc"
namespace="urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2"/>
        <file type="QDT" name="UBL-QualifiedDataTypes-2.1.xsd"
              prefix="qdt"
namespace="urn:oasis:names:specification:ubl:schema:xsd:QualifiedDataTypes-2"/>
        <file type="UDT" name="UBL-UnqualifiedDataTypes-2.1.xsd"
              prefix="udt"
namespace="urn:oasis:names:specification:ubl:schema:xsd:UnqualifiedDataTypes-2"/>
        <file type="EXT" name="UBL-CommonExtensionComponents-2.1.xsd"
              prefix="ext"
namespace="urn:oasis:names:specification:ubl:schema:xsd:CommonExtensionComponents-2">
          <elements>
           <xsd:element ref="ext:UBLExtensions" minOccurs="0" maxOccurs="1">
              <xsd:annotation>
                 <xsd:documentation>A container for all extensions present in the document.</xsd:documentation>
              </xsd:annotation>
           </xsd:element>
          </elements>
        </file>
      </dir>
      <dir name="maindoc">
        <files type="DABIE" name="UBL-%n-2.1.xsd"
               namespace="urn:oasis:names:specification:ubl:schema:xsd:%n-2">
          <element-documentation>This element MUST be conveyed as the root element in any instance document based on this Schema expression</element-documentation>
        </files>
      </dir>
    </dir>
  </configuration>

The example for a user-defined extension for UBL 2.1 is as follows for the committee's signature extension (note how there is no duplication needed for the copyright or other metadata to be reused from UBL 2.1):

<configuration xmlns:xsd="http://www.w3.org/2001/XMLSchema"
               version="2.1">
    <dir name="xsd" runtime-name="xsdrt">
      <dir name="common">
        <file type="XABIE" name="UBL-CommonSignatureComponents-2.1.xsd"
              abie="UBLDocumentSignatures"
namespace="urn:oasis:names:specification:ubl:schema:xsd:CommonSignatureComponents-2"/>
        <file type="SABIE" name="UBL-SignatureAggregateComponents-2.1.xsd"
              prefix="sac"
namespace="urn:oasis:names:specification:ubl:schema:xsd:SignatureAggregateComponents-2">
          <imports>

   <!- - ===== Incorporate W3C signature specification- ->
   <xsd:import namespace="http://www.w3.org/2000/09/xmldsig#" 
               schemaLocation="UBL-xmldsig-core-schema-2.1.xsd"/>

   <!- - ===== Incorporate ETSI signature specifications- ->
   <xsd:import namespace="http://uri.etsi.org/01903/v1.3.2#" 
               schemaLocation="UBL-XAdESv132-2.1.xsd"/>
   <xsd:import namespace="http://uri.etsi.org/01903/v1.4.1#"
               schemaLocation="UBL-XAdESv141-2.1.xsd"/>
          </imports>
          <elements xmlns:ds="http://www.w3.org/2000/09/xmldsig#"
                    abie="SignatureInformation">
         <xsd:element ref="ds:Signature" minOccurs="0" maxOccurs="1">
           <xsd:annotation>
             <xsd:documentation>This is a single digital signature as defined by the W3C specification.</xsd:documentation>
           </xsd:annotation>
         </xsd:element>
          </elements>
        </file>
        <file type="SBBIE" name="UBL-SignatureBasicComponents-2.1.xsd"
              prefix="sbc"
namespace="urn:oasis:names:specification:ubl:schema:xsd:SignatureBasicComponents-2"/>
      </dir>
    </dir>
  </configuration>

The example for a user-defined additional document for UBL 2.1 is as follows for a fictional pair of Return Authorization documents:

<configuration xmlns:xsd="http://www.w3.org/2001/XMLSchema"
               version="2.1">
  <!- -
    This is the configuration of an example of additional documents for UBL 2.1
  - ->
    <comment>
  Library:           My library of Return Authorization documents
  Module:            %f
  Generated on:      %z
</comment>
    <copyright position="end">
  Test copyright
</copyright>
    <dir name="cva">
      <file type="CVA" name="MyRA-Qualifications.cva"
            skeleton-uri="UBL-2.1-CVA-Skeleton.cva"/>
    </dir>
    <dir name="xsd" runtime-name="xsdrt">
      <dir name="mydoc">
        <file type="SABIE" name="MyRAAggregateComponents.xsd" prefix="raa"
      namespace="urn:X-MyCompany:xsd:MyRARequestResponse:AggregateComponents"/>
        <file type="SBBIE" name="MyRABasicComponents.xsd" prefix="rab" 
          namespace="urn:X-MyCompany:xsd:MyRARequestResponse:BasicComponents"/>
        <files type="AABIE" name="My%n.xsd"
               namespace="urn:X-MyCompany:xsd:My%n"/>
      </dir>
    </dir>
  </configuration>
 
Crane-gc2ublndr.xsl $Id: Crane-gc2ublndr.xsl,v 1.58 2015/07/26 21:31:54 admin Exp $
Crane-commonndr.xsl $Id: Crane-commonndr.xsl,v 1.22 2015/07/26 21:30:29 admin Exp $
Crane-commonndr.xsl $Id: Crane-utilndr.xsl,v 1.4 2015/06/27 02:32:57 admin Exp $
ndrSubset.xsl $Id: ndrSubset.xsl,v 1.12 2015/06/27 02:32:58 admin Exp $
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.CraneSoftwrights.com/ns/xslstyle" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:gu="urn:X-gc2ublndr" exclude-result-prefixes="xs gu xsd" version="2.0"><xsl:param name="common-library-singleton-model-name" as="xsd:string?" select="()"/><xsl:variable name="gu:I774491345" as="document-node()" select="/"/><xsl:param name="base-uri" as="xsd:anyURI?" select="()"/><xsl:variable name="gu:O387245672" as="document-node()?" select="if( $base-uri ) then for $u in resolve-uri( $base-uri, document-uri(/) ) return if( doc-available($u) ) then doc($u) else () else ()"/><xsl:variable name="gu:I258163781" as="xsd:string+" select="('UBLName','ComponentName','Name')"/><xsl:variable name="gu:O193622836" as="xsd:string?"><xsl:variable name="models" as="element(model)+"><xsl:for-each-group select="$gu:I774491345/*/*/Row/gu:I154898269(.,'ModelName')" group-by="."><model name="{.}" count-bies="{count($gu:I774491345/*/*/Row[gu:I154898269(.,'ModelName')=current()])}" count-abies="{count($gu:I774491345/*/*/Row[gu:I154898269(.,'ModelName')=current()]                                         [gu:I154898269(.,'ComponentType')='ABIE'])}"/></xsl:for-each-group></xsl:variable><xsl:if test="count($models[@count-abies&gt;1])&gt;1"><xsl:message terminate="yes"><xsl:text>Only one model can have more than one ABIE as the </xsl:text><xsl:text>library model.</xsl:text></xsl:message></xsl:if><xsl:if test="count($models[@count-abies&gt;1])=0 and not($common-library-singleton-model-name)"><xsl:message terminate="yes"><xsl:text>When all models have only one ABIE then the model </xsl:text><xsl:text>to be considered the library model has to be </xsl:text><xsl:text>identified using the </xsl:text><xsl:text>"common-library-singleton-model-name" invocation </xsl:text><xsl:text>argument.</xsl:text></xsl:message></xsl:if><xsl:sequence select="if( $common-library-singleton-model-name ) then $common-library-singleton-model-name else gu:O129081890($gu:I774491345)"/></xsl:variable><xsl:function name="gu:O129081890" as="xsd:string?"><xsl:param name="gc" as="document-node()?"/><xsl:variable name="modelsWithMoreThanOneABIE" as="xsd:string*"><xsl:for-each-group group-by="gu:I154898269(.,'ModelName')" select="$gc/*/SimpleCodeList/Row[gu:I154898269(.,'ComponentType')='ABIE']"><xsl:if test="count(current-group())&gt;1"><xsl:value-of select="current-grouping-key()"/></xsl:if></xsl:for-each-group></xsl:variable><xsl:if test="count($modelsWithMoreThanOneABIE) &gt; 1"><xsl:message terminate="yes"><xsl:text>More than one common library module identified in </xsl:text><xsl:value-of select="document-uri($gc)"/><xsl:text> in that there are </xsl:text><xsl:value-of select="count($modelsWithMoreThanOneABIE)"/><xsl:text> models with more than one ABIE: </xsl:text><xsl:value-of select="$modelsWithMoreThanOneABIE" separator=","/></xsl:message></xsl:if><xsl:sequence select="if( empty($modelsWithMoreThanOneABIE) ) then if( $gc is $gu:O387245672 ) then () else gu:O129081890($gu:O387245672) else $modelsWithMoreThanOneABIE"/></xsl:function><xsl:function name="gu:I154898269" as="element(SimpleValue)?"><xsl:param name="row" as="element(Row)"/><xsl:param name="col" as="xsd:string*"/><xsl:variable name="return" as="element(SimpleValue)*" select="$row/Value[@ColumnRef=$col]/SimpleValue"/><xsl:if test="count($return) &gt; 1"><xsl:message terminate="yes"><xsl:text>Data error: multiple genericode values in a single </xsl:text><xsl:text>row for column reference</xsl:text><xsl:if test="count($col)&gt;1">s</xsl:if>: <xsl:text/><xsl:value-of select="$col" separator=","/> at <xsl:text/><xsl:for-each select="$row/ancestor-or-self::*"><xsl:text/>/<xsl:value-of select="name(.)"/><xsl:if test="self::Row">[<xsl:number/>]</xsl:if></xsl:for-each></xsl:message></xsl:if><xsl:sequence select="$return"/></xsl:function><xsl:function name="gu:O110641620" as="xsd:string?"><xsl:param name="item" as="item()?"/><xsl:sequence select="translate(normalize-space($item),' ','')"/></xsl:function><xsl:function name="gu:O96811418" as="xsd:string?"><xsl:param name="row" as="element(Row)"/><xsl:param name="col" as="xsd:string+"/><xsl:sequence select="gu:O110641620(gu:I154898269($row,$col))"/></xsl:function><xsl:param name="base-config-uri" select="()" as="xsd:anyURI?"/><xsl:param name="config-uri" required="yes" as="xsd:anyURI"/><xsl:variable name="gu:I86054593" as="document-node()?" select="if( $config-uri ) then for $u in resolve-uri( $config-uri, document-uri(/) ) return if( doc-available($u) ) then doc($u) else () else ()"/><xsl:variable name="gu:O77449134" as="element()*"><xsl:variable name="files" select="$gu:I86054593//(file | files)"/><xsl:variable name="message"><xsl:if test="count( ( $files[@type='DABIE'][1], $files[@type='XABIE'][1], $files[@type='AABIE'][1] ) ) != 1 or $files[not(@type=('DABIE','CABIE','CBBIE','QDT','UDT','EXT', 'XABIE','AABIE','SABIE','SBBIE','CVA'))]"><xsl:text>Files can be created only for one type of output, </xsl:text><xsl:text>either UBL documents (DABIE), extensions (XABIE) or </xsl:text><xsl:text>additional non-UBL documents (AABIE).
</xsl:text></xsl:if><xsl:if test="$files[@type=('SABIE','SBBIE')] and not($files[@type=('XABIE','AABIE')])"><xsl:text>Supplementary common library modules can only be </xsl:text><xsl:text>created for extensions or additional documents.
</xsl:text></xsl:if><xsl:if test="$files[@type=('CABIE','CBBIE')] and $files[@type=('XABIE','AABIE')]"><xsl:text>Common library modules can only be created when not </xsl:text><xsl:text>creating extensions or additional documents. </xsl:text><xsl:text>Reference common library modules used in a common </xsl:text><xsl:text>library configuration.
</xsl:text></xsl:if><xsl:if test="count($files[@type='CVA'])&gt;1"><xsl:text>Can create only a single CVA file at a time.
</xsl:text></xsl:if><xsl:for-each select="$files[self::files and @prefix]"><xsl:text>A prefix cannot be specified when creating multiple </xsl:text><xsl:text>files.</xsl:text><xsl:value-of select="gu:O70408304(.)"/><xsl:text>
</xsl:text></xsl:for-each></xsl:variable><xsl:if test="normalize-space($message)"><xsl:message terminate="yes" select="$message"/></xsl:if><xsl:sequence select="$files"/></xsl:variable><xsl:variable name="gu:I64540945" as="document-node()?" select="if( $base-config-uri ) then for $u in resolve-uri( $base-config-uri, document-uri(/) ) return if( doc-available($u) ) then doc($u) else () else ()"/><xsl:variable name="gu:I59576257" as="document-node()"><xsl:document><combination><xsl:for-each select="$gu:I86054593,$gu:I64540945"><xsl:for-each select="*"><xsl:copy><xsl:copy-of select="@*"/><xsl:attribute name="xml:base" select="base-uri(.)"/><xsl:copy-of select="node()"/></xsl:copy></xsl:for-each></xsl:for-each></combination></xsl:document></xsl:variable><xsl:key name="gu:O55320810" match="file|files" use="@type"/><xsl:variable name="gu:O51632756" as="xsd:string?" select="gu:O129081890($gu:O387245672)"/><xsl:variable name="gu:I48405709" as="element(SimpleValue)*"><xsl:variable name="specifiedDocumentABIEs" select="(key('gu:O55320810','XABIE',$gu:I59576257), key('gu:O55320810','AABIE',$gu:I59576257))/@abie"/><xsl:choose><xsl:when test="$specifiedDocumentABIEs"><xsl:sequence select="$specifiedDocumentABIEs/ key('gu:O45558314',.,$gu:I774491345)/gu:I154898269(.,$gu:I258163781)"/></xsl:when><xsl:otherwise><xsl:for-each-group select="/*/SimpleCodeList/ Row[gu:I154898269(.,'ModelName')!=$gu:O193622836] [gu:I154898269(.,'ComponentType')='ABIE']/ gu:I154898269(.,$gu:I258163781)" group-by="."><xsl:sequence select="."/></xsl:for-each-group></xsl:otherwise></xsl:choose></xsl:variable><xsl:variable name="gu:O43027296" as="xsd:string" select="concat(key('gu:O55320810','CBBIE',$gu:I59576257)/@prefix,':')"/><xsl:variable name="gu:O40762702" as="xsd:string" select="concat(key('gu:O55320810','CABIE',$gu:I59576257)/@prefix,':')"/><xsl:variable name="gu:I38724567" as="xsd:string" select="concat(key('gu:O55320810','SBBIE',$gu:I59576257)/@prefix,':')"/><xsl:variable name="gu:O36880540" as="xsd:string" select="concat(key('gu:O55320810','SABIE',$gu:I59576257)/@prefix,':')"/><xsl:function name="gu:O35204152" as="xsd:string"><xsl:param name="name" as="xsd:string"/><xsl:param name="string" as="xsd:string"/><xsl:value-of><xsl:analyze-string select="$string" regex="%(.)"><xsl:matching-substring><xsl:value-of select="if(regex-group(1)='%') then '%' else if(regex-group(1)='f') then $name else if(regex-group(1)='n') then replace($name,'.*/','') else if(regex-group(1)='t') then format-dateTime( current-dateTime(), '[Y0001]-[M01]-[D01] [H01]:[m01][Z]' ) else if(regex-group(1)='z') then format-dateTime( adjust-dateTime-to-timezone(current-dateTime(),xsd:dayTimeDuration('PT0H')), '[Y0001]-[M01]-[D01] [H01]:[m01]z' ) else ."/></xsl:matching-substring><xsl:non-matching-substring><xsl:value-of select="."/></xsl:non-matching-substring></xsl:analyze-string></xsl:value-of></xsl:function><xsl:function name="gu:O70408304" as="xsd:string"><xsl:param name="this" as="element()"/><xsl:value-of><xsl:for-each select="$this/ancestor-or-self::*"><xsl:text/>/<xsl:value-of select="name(.)"/><xsl:if test="parent::*">[<xsl:number/>]</xsl:if></xsl:for-each><xsl:text>: </xsl:text><xsl:for-each select="$this"><xsl:text/>&lt;<xsl:value-of select="name(.)"/><xsl:for-each select="@*"><xsl:value-of select="concat(' ',name(.),'=&#34;',.,'&#34;')"/></xsl:for-each><xsl:text>&gt;</xsl:text></xsl:for-each></xsl:value-of></xsl:function><xsl:param name="reveal-non-subset" as="xsd:string" select="'no'"/><xsl:param name="subset-result" as="xsd:string" select="'no'"/><xsl:param name="subset-model-regex" as="xsd:string?"/><xsl:param name="subset-column-name" as="xsd:string?"/><xsl:variable name="gu:O33673536" as="xsd:string?" select="translate(normalize-space($subset-column-name),' ','')"/><xsl:function name="gu:I30979653" as="xsd:boolean"><xsl:param name="gu:O32270472" as="element(Row)"/><xsl:sequence select="not($gu:O33673536) or not(normalize-space(gu:I154898269($gu:O32270472,$gu:O33673536))='0')"/></xsl:function><xsl:variable name="gu:O29788128" as="xsd:boolean" select="exists($subset-column-name) or exists($subset-model-regex) or lower-case($subset-result)!='no'"/><xsl:function name="gu:I27660405" as="xsd:boolean"><xsl:param name="gu:O28684864" as="element(Row)"/><xsl:sequence select="if( not( $gu:O29788128 ) ) then true() else ( some $gu:O26706598 in $gu:O25816378 satisfies $gu:O26706598 is $gu:O28684864 )"/></xsl:function><xsl:variable name="gu:O25816378" as="element(Row)*"><xsl:if test="$gu:O29788128"><xsl:sequence select="gu:O25816378( ($gu:I774491345,$gu:O387245672), $subset-model-regex )"/></xsl:if></xsl:variable><xsl:function name="gu:O25816378" as="element(Row)*"><xsl:param name="gu:O24202854" as="document-node()+"/><xsl:param name="gu:O23469434" as="xsd:string?"/><xsl:variable name="gu:I22779157" select="$gu:O24202854/*/SimpleCodeList/ Row[gu:I154898269(.,'ModelName')!=$gu:O193622836] [gu:I154898269(.,'ComponentType')='ABIE'] [ if( not( $gu:O23469434 ) ) then true() else matches(gu:I154898269(.,'ModelName'),$gu:O23469434)]"/><xsl:sequence select="gu:O22128324( $gu:I22779157, ( for $gu:O21513648 in $gu:O24202854 return $gu:I22779157/key('gu:O20932198', gu:I154898269(.,'ObjectClass'))/ key('gu:I20381351', gu:I154898269(.,'AssociatedObjectClass'),$gu:O21513648)))"/></xsl:function><xsl:function name="gu:O22128324" as="element(Row)*"><xsl:param name="gu:I24983591" as="element(Row)*"/><xsl:param name="gu:I19362283" as="element(Row)*"/><xsl:variable name="gu:O18890032" select="$gu:I19362283[1]"/><xsl:choose><xsl:when test="not($gu:O18890032)"><xsl:sequence select="$gu:I24983591"/></xsl:when><xsl:when test="some $gu:O18440270 in $gu:I24983591 satisfies $gu:O18440270 is $gu:O18890032"><xsl:sequence select="gu:O22128324($gu:I24983591, $gu:I19362283 except $gu:O18890032)"/></xsl:when><xsl:otherwise><xsl:sequence select="gu:O22128324( (:add this to the set found so far:) ( $gu:I24983591, $gu:O18890032 ), (:add its references to the ones being looked for:) ( $gu:I19362283, ($gu:I774491345,$gu:O387245672)/ key('gu:O20932198', gu:I154898269($gu:O18890032,'ObjectClass')) [gu:I30979653(.)]/ key('gu:I20381351', gu:I154898269(.,'AssociatedObjectClass')) ) except ( $gu:I24983591, $gu:O18890032 ) )"/></xsl:otherwise></xsl:choose></xsl:function><xsl:template name="gu:O18011426"><xsl:choose><xsl:when test="not($gu:O29788128)"/><xsl:when test="exists($subset-column-name) and ( every $gu:O17602076 in ($gu:I774491345,$gu:O387245672)/*/SimpleCodeList/Row/gu:I154898269(.,$subset-column-name) satisfies normalize-space($gu:O17602076)='' )"><xsl:text>No subset information found for named column: </xsl:text><xsl:value-of select="$subset-column-name"/></xsl:when><xsl:when test="exists($subset-model-regex) and ( every $gu:O17210918 in distinct-values( ($gu:I774491345,$gu:O387245672)/*/SimpleCodeList/Row/gu:I154898269(.,'ModelName') ) satisfies not( matches(.,$subset-model-regex) ) )"><xsl:text>No subset information found for model regex: </xsl:text><xsl:value-of select="$subset-model-regex"/></xsl:when><xsl:otherwise><xsl:for-each select="$gu:O25816378"><xsl:variable name="gu:O16836768" select="key('gu:I16478539',gu:I154898269(.,'ObjectClass'))"/><xsl:choose><xsl:when test="count($gu:O16836768)=0"><xsl:text>The ABIE appears corrupted in that it has no </xsl:text><xsl:text>BIEs: </xsl:text><xsl:value-of select="gu:I154898269(.,'DictionaryEntryName')"/><xsl:text>
</xsl:text></xsl:when><xsl:when test="not( some $gu:O32270472 in $gu:O16836768 satisfies not( gu:O16135236($gu:O32270472) ) )"><xsl:text>An ABIE cannot have all of its members excluded </xsl:text><xsl:text>in a subset: </xsl:text><xsl:value-of select="gu:I154898269(.,'DictionaryEntryName')"/><xsl:text>
</xsl:text></xsl:when></xsl:choose><xsl:for-each select="$gu:O16836768"><xsl:variable name="gu:I15805945" select="normalize-space(gu:I154898269(.,'Cardinality'))"/><xsl:variable name="gu:O15489826" select="normalize-space(gu:I154898269(.,$gu:O33673536))"/><xsl:choose><xsl:when test="not($gu:O15489826 = ('','0','0..1','1','0..n','1..n'))"><xsl:text>Invalid value "</xsl:text><xsl:value-of select="$gu:O15489826"/><xsl:text>" for subset cardinality: </xsl:text><xsl:value-of select="gu:I154898269(.,'DictionaryEntryName')"/><xsl:text>
</xsl:text></xsl:when><xsl:when test="not($gu:I15805945 = ('','0..1','1','0..n','1..n'))"><xsl:text>Invalid value "</xsl:text><xsl:value-of select="$gu:O15489826"/><xsl:text>" for original cardinality: </xsl:text><xsl:value-of select="gu:I154898269(.,'DictionaryEntryName')"/><xsl:text>
</xsl:text></xsl:when><xsl:when test="$gu:O15489826=''"/><xsl:when test="substring($gu:I15805945,1,1)='1' and not( substring($gu:O15489826,1,1)='1')"><xsl:text>The minimum cardinality cannot be lowered </xsl:text><xsl:text>from "</xsl:text><xsl:value-of select="$gu:I15805945"/><xsl:text>" to "</xsl:text><xsl:value-of select="$gu:O15489826"/><xsl:text>": </xsl:text><xsl:value-of select="gu:I154898269(.,'DictionaryEntryName')"/><xsl:text>
</xsl:text></xsl:when><xsl:when test="substring($gu:I15805945,string-length($gu:I15805945),1)='1' and substring($gu:O15489826,string-length($gu:O15489826),1)='n'"><xsl:text>The maximum cardinality cannot be raised </xsl:text><xsl:text>from "</xsl:text><xsl:value-of select="$gu:I15805945"/><xsl:text>" to "</xsl:text><xsl:value-of select="$gu:O15489826"/><xsl:text>": </xsl:text><xsl:value-of select="gu:I154898269(.,'DictionaryEntryName')"/><xsl:text>
</xsl:text></xsl:when></xsl:choose></xsl:for-each></xsl:for-each></xsl:otherwise></xsl:choose></xsl:template><xsl:function name="gu:O15186104" as="xsd:string"><xsl:param name="row" as="element(Row)"/><xsl:param name="minimumFlag" as="xsd:boolean"/><xsl:for-each select="(normalize-space(gu:I154898269($row,$gu:O33673536)) [$gu:O29788128][string(.)], normalize-space(gu:I154898269($row,'Cardinality')))[1]"><xsl:choose><xsl:when test="$minimumFlag"><xsl:value-of select="substring(.,1,1)"/></xsl:when><xsl:when test="ends-with(.,'n')">unbounded</xsl:when><xsl:otherwise><xsl:value-of select="substring(.,string-length(.),1)"/></xsl:otherwise></xsl:choose></xsl:for-each></xsl:function><xsl:function name="gu:O16135236" as="xsd:boolean"><xsl:param name="row" as="element(Row)"/><xsl:sequence select="gu:O15186104($row,true())='0' and gu:O15186104($row,false())='0'"/></xsl:function><xsl:param name="qdt-as-cva" required="yes" as="xsd:string"/><xsl:output indent="yes"/><xsl:key name="gu:O14894064" match="/*/SimpleCodeList/Row[gu:I154898269(.,'ComponentType')='ABIE']" use="if( gu:I154898269(.,'ModelName')=$gu:O193622836 ) then $gu:O193622836 else gu:I154898269(.,$gu:I258163781)"/><xsl:key name="gu:O14613044" match="/*/SimpleCodeList/Row[gu:I154898269(.,'ComponentType')='BBIE']" use="gu:I154898269(.,$gu:I258163781)"/><xsl:key name="gu:O45558314" match="/*/SimpleCodeList/Row[gu:I154898269(.,'ComponentType')='ABIE']" use="gu:I154898269(.,$gu:I258163781)"/><xsl:key name="gu:I20381351" match="/*/SimpleCodeList/Row[gu:I154898269(.,'ComponentType')='ABIE']" use="gu:I154898269(.,'ObjectClass')"/><xsl:key name="gu:O14342432" match="/*/SimpleCodeList/Row" use="gu:I154898269(.,'ComponentType')"/><xsl:key name="gu:O14081660" match="/*/SimpleCodeList/Row[gu:I154898269(.,'ComponentType')!='ABIE']" use="preceding-sibling::Row[gu:I154898269(.,'ComponentType')='ABIE'][1]/ gu:I154898269(.,$gu:I258163781)"/><xsl:key name="gu:I16478539" match="/*/SimpleCodeList/Row[gu:I154898269(.,'ComponentType')!='ABIE']" use="preceding-sibling::Row[gu:I154898269(.,'ComponentType')='ABIE'][1]/ gu:I154898269(.,'ObjectClass')"/><xsl:key name="gu:O13830202" match="/*/SimpleCodeList/Row[gu:I154898269(.,'ComponentType')='ASBIE']" use="preceding-sibling::Row[gu:I154898269(.,'ComponentType')='ABIE'][1]/ gu:I154898269(.,$gu:I258163781)"/><xsl:key name="gu:O20932198" match="/*/SimpleCodeList/Row[gu:I154898269(.,'ComponentType')='ASBIE']" use="preceding-sibling::Row[gu:I154898269(.,'ComponentType')='ABIE'][1]/ gu:I154898269(.,'ObjectClass')"/><xsl:key name="gu:I13587567" match="/*/SimpleCodeList/Row[gu:I154898269(.,'ComponentType')='ASBIE']" use="gu:I154898269(.,'AssociatedObjectClass')"/><xsl:key name="gu:I13353299" match="/*/SimpleCodeList/Row[gu:I154898269(.,'ComponentType')='BBIE']" use="gu:I154898269(.,'DataType')"/><xsl:variable name="gu:I13126971" as="element(SimpleValue)*"><xsl:for-each-group select="/*/SimpleCodeList/Row/gu:I154898269(.,'ModelName')" group-by="."><xsl:sequence select="."/></xsl:for-each-group></xsl:variable><xsl:variable name="gu:I12908189" as="element(SimpleValue)*"><xsl:for-each-group select="/*/SimpleCodeList/ Row[gu:I154898269(.,'ModelName')=$gu:O193622836] [gu:I154898269(.,'ComponentType')='ABIE']/ gu:I154898269(.,$gu:I258163781)" group-by="."><xsl:sequence select="."/></xsl:for-each-group></xsl:variable><xsl:template match="/"><xsl:variable name="messages"><xsl:choose><xsl:when test="not(normalize-space($config-uri))"><xsl:text>Configuration uri cannot be empty.</xsl:text></xsl:when><xsl:when test="not($gu:I86054593)"><xsl:text>Cannot open specified configuration file "</xsl:text><xsl:value-of select="$config-uri"/><xsl:text>" resolved relative to the input genericode file: </xsl:text><xsl:value-of select="document-uri(/)"/></xsl:when><xsl:when test="$base-config-uri and not($gu:I64540945)"><xsl:text>Cannot open specified common configuration file "</xsl:text><xsl:value-of select="$base-config-uri"/><xsl:text>" resolved relative to the input genericode file: </xsl:text><xsl:value-of select="document-uri(/)"/></xsl:when><xsl:when test="($gu:O77449134[@type=('XABIE','AABIE')]) and not($gu:O387245672)"><xsl:text>Cannot open specified common genericode file "</xsl:text><xsl:value-of select="$base-uri"/><xsl:text>" resolved relative to the input genericode file: </xsl:text><xsl:value-of select="document-uri(/)"/></xsl:when><xsl:otherwise><xsl:call-template name="gu:I12696579"/></xsl:otherwise></xsl:choose></xsl:variable><xsl:if test="normalize-space($messages)"><xsl:message terminate="yes" select="$messages"/></xsl:if><xsl:variable name="makeConfig" select="$gu:I59576257/*/configuration[1]"/><xsl:apply-templates select="key('gu:O55320810','CVA',$makeConfig)"/><xsl:for-each select="false(), if( $makeConfig//dir[@runtime-name] ) then true() else ()"><xsl:choose><xsl:when test="$gu:O77449134[@type='XABIE']"><xsl:apply-templates select="key('gu:O55320810','XABIE',$makeConfig)"><xsl:with-param name="runtime" tunnel="yes" select="."/><xsl:with-param name="schemaType" tunnel="yes" select="'XABIE'"/></xsl:apply-templates><xsl:apply-templates select="key('gu:O55320810','SABIE',$makeConfig)"><xsl:with-param name="runtime" tunnel="yes" select="."/><xsl:with-param name="schemaType" tunnel="yes" select="'SABIE'"/></xsl:apply-templates><xsl:apply-templates select="key('gu:O55320810','SBBIE',$makeConfig)"><xsl:with-param name="runtime" tunnel="yes" select="."/><xsl:with-param name="schemaType" tunnel="yes" select="'SBBIE'"/></xsl:apply-templates></xsl:when><xsl:when test="$gu:O77449134[@type='AABIE']"><xsl:apply-templates select="key('gu:O55320810','AABIE',$makeConfig)"><xsl:with-param name="runtime" tunnel="yes" select="."/><xsl:with-param name="schemaType" tunnel="yes" select="'AABIE'"/></xsl:apply-templates><xsl:apply-templates select="key('gu:O55320810','SABIE',$makeConfig)"><xsl:with-param name="runtime" tunnel="yes" select="."/><xsl:with-param name="schemaType" tunnel="yes" select="'SABIE'"/></xsl:apply-templates><xsl:apply-templates select="key('gu:O55320810','SBBIE',$makeConfig)"><xsl:with-param name="runtime" tunnel="yes" select="."/><xsl:with-param name="schemaType" tunnel="yes" select="'SBBIE'"/></xsl:apply-templates></xsl:when><xsl:otherwise><xsl:apply-templates select="key('gu:O55320810','DABIE',$makeConfig)"><xsl:with-param name="runtime" tunnel="yes" select="."/><xsl:with-param name="schemaType" tunnel="yes" select="'DABIE'"/></xsl:apply-templates><xsl:apply-templates select="key('gu:O55320810','CABIE',$makeConfig)"><xsl:with-param name="runtime" tunnel="yes" select="."/><xsl:with-param name="schemaType" tunnel="yes" select="'CABIE'"/></xsl:apply-templates><xsl:apply-templates select="key('gu:O55320810','CBBIE',$makeConfig)"><xsl:with-param name="runtime" tunnel="yes" select="."/><xsl:with-param name="schemaType" tunnel="yes" select="'CBBIE'"/></xsl:apply-templates></xsl:otherwise></xsl:choose></xsl:for-each></xsl:template><xsl:template match="configuration//file"><xsl:param name="runtime" tunnel="yes" as="xsd:boolean"/><xsl:variable name="module" select="gu:I12491795( ., ancestor::configuration, $runtime )"/><xsl:message select="'Creating',$module,'...'"/><xsl:variable name="moduleABIEs" select="if( @type=('DABIE','XABIE','AABIE') ) then if( @abie ) then $gu:I48405709[.=current()/@abie] else $gu:I48405709[1] else (:'CABIE','SABIE','CBBIE','SBBIE':) ( $gu:I48405709, $gu:I12908189 )"/><xsl:if test="@abie and not( $moduleABIEs )"><xsl:message terminate="yes"><xsl:text>Cannot find requested ABIE in the set of document </xsl:text><xsl:text>ABIES: </xsl:text><xsl:value-of select="@abie"/></xsl:message></xsl:if><xsl:if test="if( not(@abie) ) then true() else gu:I27660405($moduleABIEs/../..)"><xsl:result-document href="{$module}"><xsl:call-template name="gu:I12293513"><xsl:with-param name="module" select="$module"/><xsl:with-param name="moduleABIEs" tunnel="yes" select="$moduleABIEs"/><xsl:with-param name="moduleBBIEs" tunnel="yes" select="$moduleABIEs/key('gu:O14081660',.,$gu:I774491345) [gu:I154898269(.,'ComponentType')='BBIE']/ gu:I154898269(.,$gu:I258163781)"/><xsl:with-param name="namespace" select="gu:O35204152($module,@namespace)"/></xsl:call-template></xsl:result-document></xsl:if></xsl:template><xsl:template match="configuration//files"><xsl:param name="runtime" tunnel="yes" as="xsd:boolean"/><xsl:variable name="thisFile" select="."/><xsl:variable name="singleDocumentNames" as="xsd:string*" select="key('gu:O55320810',@type,$gu:I59576257)/@abie"/><xsl:for-each select="$gu:I48405709[not(.=$singleDocumentNames)]"><xsl:variable name="thisDocumentABIE" select="."/><xsl:for-each select="$thisFile"><xsl:variable name="module" select="gu:O35204152($thisDocumentABIE,( gu:I12491795( ., ancestor::configuration, $runtime) ) )"/><xsl:if test="gu:I27660405( $thisDocumentABIE/../.. )"><xsl:message select="'Creating',$module,'...'"/><xsl:result-document href="{$module}"><xsl:call-template name="gu:I12293513"><xsl:with-param name="module" select="$module"/><xsl:with-param name="moduleABIEs" tunnel="yes" select="$thisDocumentABIE"/><xsl:with-param name="moduleBBIEs" tunnel="yes" select="key('gu:O14081660',$thisDocumentABIE,$gu:I774491345) [gu:I154898269(.,'ComponentType')='BBIE']/ gu:I154898269(.,$gu:I258163781)"/><xsl:with-param name="namespace" select="gu:O35204152($thisDocumentABIE,@namespace)"/><xsl:with-param name="schemaType" tunnel="yes" select="@type"/></xsl:call-template></xsl:result-document></xsl:if></xsl:for-each></xsl:for-each></xsl:template><xsl:template match="configuration//file[@type='CVA']" priority="1"><xsl:variable name="skeleton" select="document(@skeleton-uri)"/><xsl:variable name="module" select="gu:I12491795( ., ancestor::configuration, false() )"/><xsl:message select="'Creating',$module,'...'"/><xsl:result-document href="{$module}"><xsl:apply-templates mode="gu:I12101427" select="$skeleton"/></xsl:result-document></xsl:template><xsl:template name="gu:I12293513"><xsl:param name="module" as="xsd:string"/><xsl:param name="namespace" as="xsd:string"/><xsl:param name="schemaType" tunnel="yes" as="xsd:string"/><xsl:param name="runtime" tunnel="yes" as="xsd:boolean"/><xsl:param name="moduleABIEs" tunnel="yes" as="element(SimpleValue)*"/><xsl:param name="moduleBBIEs" tunnel="yes" as="element(SimpleValue)*"/><xsl:variable name="thisFile" select="."/><xsl:text>
</xsl:text><xsl:for-each select="(comment,ancestor::configuration/comment)[1]"><xsl:comment><xsl:value-of select="gu:O35204152($module,.)"/></xsl:comment><xsl:text>
</xsl:text></xsl:for-each><xsl:for-each select="(copyright,ancestor::configuration/copyright)[1][@position='start']"><xsl:comment> ===== Copyright Notice ===== </xsl:comment><xsl:text>
</xsl:text><xsl:comment select="."/></xsl:for-each><xsd:schema targetNamespace="{$namespace}" elementFormDefault="qualified" attributeFormDefault="unqualified" version="{ancestor::configuration/@version}"><xsl:variable name="otherParticipatingFiles" as="element(file)*"><xsl:if test="$schemaType=('XABIE','AABIE') and $moduleABIEs[not(gu:I11915251(.))]"><xsl:sequence select="key('gu:O55320810','SABIE',$gu:I59576257)"/></xsl:if><xsl:if test="$schemaType=('XABIE','AABIE','SABIE') and $moduleBBIEs[not(gu:I11915251(.))]"><xsl:sequence select="key('gu:O55320810','SBBIE',$gu:I59576257)"/></xsl:if><xsl:if test="( (:a document ABIE needs access to the library:) ( $schemaType='DABIE' and $moduleABIEs[not(gu:I11915251(.))] ) or (:an extension construct needs access to the library:) ( $schemaType=('XABIE','AABIE','SABIE') and $moduleABIEs[gu:I11915251(.)] ) or (:check ASBIEs for pointing to common library:) $moduleABIEs/key('gu:O13830202',.,$gu:I774491345)/ gu:I154898269(.,'AssociatedObjectClass') [gu:I11915251(.)])"><xsl:sequence select="key('gu:O55320810','CABIE',$gu:I59576257)"/></xsl:if><xsl:if test="( $schemaType='DABIE' and $moduleBBIEs[not(gu:I11915251)] ) or ( $schemaType='CABIE' and $moduleBBIEs ) or ( $schemaType=('XABIE','AABIE','SABIE') and $moduleBBIEs[gu:I11915251(.)] )"><xsl:sequence select="key('gu:O55320810','CBBIE',$gu:I59576257)"/></xsl:if><xsl:if test="$schemaType=('CBBIE','SBBIE')"><xsl:sequence select="key('gu:O55320810','QDT',$gu:I59576257), key('gu:O55320810','UDT',$gu:I59576257)"/></xsl:if><xsl:if test="$schemaType=('DABIE','AABIE')"><xsl:sequence select="key('gu:O55320810','EXT',$gu:I59576257)"/></xsl:if></xsl:variable><xsl:namespace name="" select="$namespace"/><xsl:for-each select="(:first check self-referencing common aggregates:) .[$schemaType=('CABIE','SABIE')], (:then add in all of the participating files:) $otherParticipatingFiles"><xsl:namespace name="{@prefix}" select="@namespace"/></xsl:for-each><xsl:copy-of select=".//namespace::*"/><xsl:if test="not($runtime) and not($schemaType=('CBBIE','SBBIE'))"><xsl:copy-of select="(type-documentation, $gu:I59576257/combination/configuration/type-documentation)[1]// namespace::*"/><xsl:copy-of select="(element-documentation, $gu:I59576257/combination/configuration/element-documentation)[1]// namespace::*"/></xsl:if><xsl:if test="$otherParticipatingFiles or imports/node()"><xsl:call-template name="gu:I11734717"><xsl:with-param name="section">Imports</xsl:with-param></xsl:call-template><xsl:for-each select="$otherParticipatingFiles"><xsl:element name="xsd:import"><xsl:attribute name="namespace" select="@namespace"/><xsl:attribute name="schemaLocation" select="gu:I12491795(.,$thisFile,$runtime)"/></xsl:element></xsl:for-each><xsl:copy-of select="imports/node()"/></xsl:if><xsl:call-template name="gu:O11559572"/><xsl:call-template name="gu:O11389578"/></xsd:schema><xsl:for-each select="(copyright,ancestor::configuration/copyright)[1][@position='end']"><xsl:comment> ===== Copyright Notice ===== </xsl:comment><xsl:comment select="."/></xsl:for-each></xsl:template><xsl:template name="gu:O11559572"><xsl:param name="moduleABIEs" tunnel="yes" as="element(SimpleValue)*"/><xsl:param name="moduleBBIEs" tunnel="yes" as="element(SimpleValue)*"/><xsl:param name="schemaType" tunnel="yes" as="xsd:string"/><xsl:param name="runtime" tunnel="yes" as="xsd:boolean"/><xsl:variable name="thisFile" select="."/><xsl:call-template name="gu:I11734717"><xsl:with-param name="section">Element Declarations</xsl:with-param></xsl:call-template><xsl:choose><xsl:when test="$schemaType=('DABIE','XABIE','AABIE')"><xsl:element name="xsd:element"><xsl:attribute name="name" select="$moduleABIEs"/><xsl:attribute name="type" select="concat($moduleABIEs,'Type')"/><xsl:for-each select="(element-documentation, $gu:I59576257/combination/element-documentation) [1][not($runtime)]"><xsl:element name="xsd:annotation"><xsl:element name="xsd:documentation"><xsl:copy-of select="node()" copy-namespaces="no"/></xsl:element></xsl:element></xsl:for-each></xsl:element></xsl:when><xsl:when test="$schemaType=('CABIE','SABIE')"><xsl:variable name="nameTypePairs" as="element(pair)*"><xsl:for-each select="$moduleABIEs[$schemaType='CABIE' or not(gu:I11915251(.))] [not(.=$gu:I48405709)]"><pair den="{gu:I154898269(../..,'DictionaryEntryName')}"><xsl:attribute name="gu:I27660405" select="gu:I27660405(../..[gu:I154898269(.,'ComponentType')='ABIE'])"/><name><xsl:value-of select="."/></name><xsl:text>&#xD;</xsl:text><type><xsl:value-of select="."/></type></pair></xsl:for-each><xsl:for-each select="$moduleABIEs/key('gu:O13830202',.,$gu:I774491345)/ gu:I154898269(.,$gu:I258163781) [$schemaType='CABIE' or ( not(gu:I11915251(gu:I154898269(../..,$gu:I258163781))) and not(.=$moduleABIEs) )]"><pair den="{gu:I154898269(../..,'DictionaryEntryName')}"><xsl:attribute name="gu:I27660405" select="gu:I27660405(../../preceding-sibling::Row [gu:I154898269(.,'ComponentType')='ABIE'][1])"/><name><xsl:value-of select="."/></name><xsl:text>&#xD;</xsl:text><type><xsl:for-each select="translate(gu:I154898269(../..,'AssociatedObjectClass'),' ','')"><xsl:if test="$gu:O387245672/key('gu:O14342432','ABIE',.) [gu:I154898269(.,'ModelName')=$gu:O51632756] [gu:I154898269(.,$gu:I258163781)=current()]"><xsl:value-of select="$gu:O40762702"/></xsl:if><xsl:value-of select="."/></xsl:for-each></type></pair></xsl:for-each></xsl:variable><xsl:for-each-group select="$nameTypePairs" group-by="."><xsl:sort select="."/><xsl:choose><xsl:when test="every $gu:I27660405 in current-group()/@gu:I27660405 satisfies( not(xsd:boolean($gu:I27660405)) )"><xsl:if test="not($runtime)"><xsl:comment><xsl:text>Subset excludes: den="</xsl:text><xsl:value-of select="@den"/><xsl:text>"</xsl:text></xsl:comment><xsl:text>
   </xsl:text></xsl:if></xsl:when><xsl:otherwise><xsl:element name="xsd:element"><xsl:attribute name="name" select="name"/><xsl:attribute name="type" select="concat(type,'Type')"/></xsl:element></xsl:otherwise></xsl:choose></xsl:for-each-group></xsl:when><xsl:when test="$schemaType=('CBBIE','SBBIE')"><xsl:for-each-group select="$moduleBBIEs[ gu:I27660405(../../preceding-sibling::Row [gu:I154898269(.,'ComponentType')='ABIE'][1])]" group-by="."><xsl:sort select="."/><xsl:if test="$schemaType='CBBIE' or not(gu:I11915251(.))"><xsl:element name="xsd:element"><xsl:attribute name="name" select="."/><xsl:attribute name="type" select="concat(.,'Type')"/></xsl:element></xsl:if></xsl:for-each-group></xsl:when></xsl:choose></xsl:template><xsl:template name="gu:O11389578"><xsl:param name="schemaType" tunnel="yes" as="xsd:string"/><xsl:param name="runtime" tunnel="yes" as="xsd:boolean"/><xsl:param name="moduleABIEs" tunnel="yes" as="element(SimpleValue)*"/><xsl:param name="moduleBBIEs" tunnel="yes" as="element(SimpleValue)*"/><xsl:variable name="thisFile" select="."/><xsl:variable name="documentation" select="(type-documentation, $gu:I59576257/combination/configuration/type-documentation) [1][not($runtime)]"/><xsl:choose><xsl:when test="$schemaType=('DABIE','CABIE','XABIE','AABIE','SABIE')"><xsl:variable name="thisCBCprefixColon" select="if( $schemaType = ('DABIE','CABIE') ) then $gu:O43027296 else $gu:I38724567"/><xsl:variable name="thisCACprefixColon" select="if( $schemaType = 'DABIE' ) then $gu:O40762702 else if( $schemaType = ('XABIE','AABIE','SABIE') ) then $gu:O36880540 else ''"/><xsl:call-template name="gu:I11734717"><xsl:with-param name="section" select="'Type Definitions', 'Aggregate Business Information Entity Type Definitions'"/></xsl:call-template><xsl:for-each select="$moduleABIEs[not( $schemaType=('CABIE','SABIE') ) or not( .=$gu:I48405709 )] [not(gu:I11915251(.))]/../.."><xsl:sort select="gu:I154898269(.,$gu:I258163781)"/><xsl:variable name="thisABIE" select="."/><xsl:choose><xsl:when test="not( gu:I27660405(.) )"><xsl:if test="not($runtime)"><xsl:comment><xsl:text>Subset excludes: den="</xsl:text><xsl:value-of select="gu:I154898269(.,'DictionaryEntryName')"/><xsl:text>"</xsl:text></xsl:comment><xsl:text>
   </xsl:text></xsl:if></xsl:when><xsl:otherwise><xsl:element name="xsd:complexType"><xsl:attribute name="name" select="concat(gu:I154898269(.,$gu:I258163781),'Type')"/><xsl:for-each select="$documentation"><xsl:element name="xsd:annotation"><xsl:element name="xsd:documentation"><xsl:apply-templates select="*" mode="gu:O11224512"><xsl:with-param name="bie" tunnel="yes" select="$thisABIE"/></xsl:apply-templates></xsl:element></xsl:element></xsl:for-each><xsl:element name="xsd:sequence"><xsl:if test="$schemaType=('DABIE','AABIE')"><xsl:apply-templates mode="gu:O11064162" select="key('gu:O55320810','EXT',$gu:I59576257)/elements/node()"/></xsl:if><xsl:for-each select="key('gu:O14081660', gu:I154898269($thisABIE,$gu:I258163781), $gu:I774491345)"><xsl:variable name="thisBIE" select="."/><xsl:variable name="thisBIEtype" select="gu:I154898269(.,'ComponentType')"/><xsl:variable name="thisBIEassociatedObjectClass" select="gu:I154898269(.,'AssociatedObjectClass')"/><xsl:variable name="thisBIEname" select="gu:I154898269(.,$gu:I258163781)"/><xsl:variable name="thisBIEisCommon" select="$schemaType='CABIE' or gu:I11915251($thisBIEname)"/><xsl:variable name="thisBIEmin" select="gu:O15186104(.,true())"/><xsl:variable name="thisBIEmax" select="gu:O15186104(.,false())"/><xsl:variable name="thisBIEcard" select="normalize-space(gu:I154898269(.,'Cardinality'))"/><xsl:variable name="thisBIEsubsetCard" select="normalize-space(gu:I154898269(.,$gu:O33673536))"/><xsl:variable name="gu:O10908328" select="concat( if( $thisBIEtype='BBIE' ) then if( $thisBIEisCommon ) then $gu:O43027296 else $thisCBCprefixColon else if( $thisBIEisCommon ) then $gu:O40762702 else $thisCACprefixColon ,gu:I154898269(.,$gu:I258163781))"/><xsl:choose><xsl:when test="$thisBIEsubsetCard[$gu:O29788128]='0'"><xsl:if test="not($runtime)"><xsl:comment><xsl:text>Subset excludes: ref="</xsl:text><xsl:value-of select="$gu:O10908328"/><xsl:text>" cardinality="</xsl:text><xsl:value-of select="$thisBIEcard"/><xsl:text>" den="</xsl:text><xsl:value-of select="gu:I154898269(.,'DictionaryEntryName')"/><xsl:text>"</xsl:text></xsl:comment><xsl:text>
         </xsl:text></xsl:if></xsl:when><xsl:otherwise><xsl:element name="xsd:element"><xsl:attribute name="ref" select="$gu:O10908328"/><xsl:attribute name="minOccurs" select="$thisBIEmin"/><xsl:attribute name="maxOccurs" select="$thisBIEmax"/><xsl:if test="not($runtime) and $thisBIEsubsetCard!='' and not( $thisBIEsubsetCard=$thisBIEcard ) and $gu:O29788128"><xsl:text>
            </xsl:text><xsl:comment><xsl:text>Subset changes: ref="</xsl:text><xsl:value-of select="$gu:O10908328"/><xsl:text>"; original cardinality="</xsl:text><xsl:value-of select="$thisBIEcard"/><xsl:text>" den="</xsl:text><xsl:value-of select="gu:I154898269(.,'DictionaryEntryName')"/><xsl:text>"</xsl:text></xsl:comment><xsl:text>
            </xsl:text></xsl:if><xsl:for-each select="$documentation"><xsl:element name="xsd:annotation"><xsl:element name="xsd:documentation"><xsl:apply-templates select="*" mode="gu:O11224512"><xsl:with-param name="bie" tunnel="yes" select="$thisBIE"/></xsl:apply-templates></xsl:element></xsl:element></xsl:for-each></xsl:element></xsl:otherwise></xsl:choose></xsl:for-each><xsl:copy-of select="$thisFile/elements[ @abie=gu:I154898269($thisABIE,$gu:I258163781)]/node()"/></xsl:element></xsl:element></xsl:otherwise></xsl:choose></xsl:for-each></xsl:when><xsl:when test="$schemaType=('CBBIE','SBBIE')"><xsl:call-template name="gu:I11734717"><xsl:with-param name="section" select="'Type Definitions', 'Basic Business Information Entity Type Definitions'"/></xsl:call-template><xsl:for-each-group select="$moduleBBIEs" group-by="."><xsl:sort select="concat(.,'Type')"/><xsl:if test="$schemaType = 'CBBIE' or not( gu:I11915251(.) )"><xsl:element name="xsd:complexType"><xsl:attribute name="name" select="concat(.,'Type')"/><xsl:element name="xsd:simpleContent"><xsl:element name="xsd:extension"><xsl:attribute name="base"><xsl:variable name="rawDataType" select="gu:I154898269(../..,'DataType')"/><xsl:choose><xsl:when test="contains($rawDataType, '_') and $qdt-as-cva='no'"><xsl:value-of select="concat(key('gu:O55320810','QDT',$gu:I59576257) /@prefix,':', translate($rawDataType,'_ .',''))"/></xsl:when><xsl:otherwise><xsl:variable name="dataType" select="if( contains( $rawDataType, '_' ) ) then substring-after($rawDataType,'_') else $rawDataType"/><xsl:value-of select="concat(key('gu:O55320810','UDT',$gu:I59576257) /@prefix,':', translate($dataType,' .',''))"/></xsl:otherwise></xsl:choose></xsl:attribute></xsl:element></xsl:element></xsl:element></xsl:if></xsl:for-each-group></xsl:when></xsl:choose></xsl:template><xsl:template match="*" mode="gu:O11224512"><xsl:param name="bie" tunnel="yes" as="element(Row)"/><xsl:choose><xsl:when test="*"><xsl:copy><xsl:copy-of select="@*"/><xsl:apply-templates select="*" mode="gu:O11224512"/></xsl:copy></xsl:when><xsl:otherwise><xsl:if test="gu:I154898269($bie,.)[normalize-space(.)]"><xsl:copy><xsl:copy-of select="@*"/><xsl:value-of select="gu:I154898269($bie,.)"/></xsl:copy></xsl:if></xsl:otherwise></xsl:choose></xsl:template><xsl:template match="xsd:annotation | text()" mode="gu:O11064162"><xsl:param name="runtime" tunnel="yes" as="xsd:boolean"/><xsl:if test="not($runtime)"><xsl:next-match/></xsl:if></xsl:template><xsl:template match="*" mode="gu:O11064162"><xsl:copy><xsl:copy-of select="@*"/><xsl:apply-templates mode="gu:O11064162"/></xsl:copy></xsl:template><xsl:template match="/*" mode="gu:I12101427"><xsl:copy><xsl:apply-templates mode="gu:I12101427" select="@*,node()"><xsl:with-param name="contexts" as="element(Context)*" tunnel="yes"><xsl:apply-templates select="Contexts/Context" mode="gu:I12101427"/></xsl:with-param></xsl:apply-templates></xsl:copy></xsl:template><xsl:template match="@*|node()" mode="gu:I12101427"><xsl:copy><xsl:apply-templates mode="gu:I12101427" select="@*,node()"/></xsl:copy></xsl:template><xsl:template match="InstanceMetadataSets/text() | ValueLists/text()" mode="gu:I12101427"/><xsl:template match="ValueList" mode="gu:I12101427"><xsl:param name="contexts" as="element(Context)*" tunnel="yes"/><xsl:if test="exists($contexts[tokenize(@values,'\s+')=current()/@xml:id])"><xsl:copy><xsl:apply-templates mode="gu:I12101427" select="@*,node()"/></xsl:copy></xsl:if></xsl:template><xsl:template match="InstanceMetadataSet" mode="gu:I12101427"><xsl:param name="contexts" as="element(Context)*" tunnel="yes"/><xsl:if test="exists($contexts[@metadata=current()/@xml:id])"><xsl:copy><xsl:apply-templates mode="gu:I12101427" select="@*,node()"/></xsl:copy></xsl:if></xsl:template><xsl:template match="Contexts" mode="gu:I12101427"><xsl:param name="contexts" as="element(Context)*" tunnel="yes"/><xsl:copy><xsl:copy-of select="@*,Annotation,$contexts"/></xsl:copy></xsl:template><xsl:template match="*[@NDRDataType]" mode="gu:I12101427"><xsl:variable name="contexts" select="gu:O10756824(@NDRDataType)"/><xsl:if test="normalize-space($contexts)"><xsl:copy><xsl:copy-of select="@* except @NDRDataType"/><xsl:attribute name="address" select="$contexts"/></xsl:copy></xsl:if></xsl:template><xsl:function name="gu:O10756824" as="xsd:string"><xsl:param name="dataType" as="attribute(NDRDataType)"/><xsl:value-of><xsl:for-each select="$dataType"><xsl:for-each-group select="key('gu:I13353299',.,$gu:I774491345)" group-by="gu:I154898269(.,$gu:I258163781)"><xsl:sort select="current-grouping-key()"/><xsl:if test="position()&gt;1"> | </xsl:if><xsl:value-of select="concat($gu:O43027296, current-grouping-key())"/></xsl:for-each-group></xsl:for-each></xsl:value-of></xsl:function><xsl:function name="gu:I12491795" as="xsd:string"><xsl:param name="target" as="element()"/><xsl:param name="source" as="element()"/><xsl:param name="runtime" as="xsd:boolean"/><xsl:variable name="closestTargetDir" select="($target/ancestor::dir[@name=$source/ancestor::dir/@name][1], $target/ancestor::configuration)[1]"/><xsl:variable name="closestSourceDir" select="($source/ancestor::dir[@name=$target/ancestor::dir/@name][1], $source/ancestor::configuration)[1]"/><xsl:value-of><xsl:for-each select="$source/ancestor::*[ancestor::*[. is $closestSourceDir]]"><xsl:text>../</xsl:text></xsl:for-each><xsl:for-each select="$target/ancestor::*[ancestor::*[. is $closestTargetDir]]"><xsl:value-of select="if( @runtime-name and $runtime ) then @runtime-name else @name"/><xsl:text>/</xsl:text></xsl:for-each><xsl:value-of select="$target/@name"/></xsl:value-of></xsl:function><xsl:template name="gu:I12696579"><xsl:if test="not($qdt-as-cva=('yes','no'))"><xsl:text>Invalid yes/no value for parameter "qdt-as-cva": </xsl:text><xsl:value-of select="$qdt-as-cva"/><xsl:text>
</xsl:text></xsl:if><xsl:choose><xsl:when test="boolean($base-uri) != exists($gu:O77449134[@type=('XABIE','AABIE')])"><xsl:text>Creating extension/addition constructs requires and </xsl:text><xsl:text>satisfies base-uri being specified.
</xsl:text></xsl:when></xsl:choose><xsl:for-each select="$gu:I774491345,$gu:O387245672"><xsl:choose><xsl:when test="namespace-uri(/*) != 'http://docs.oasis-open.org/codelist/ns/genericode/1.0/' or local-name(/*) != 'CodeList'"><xsl:text>Expected {http://docs.oasis-open.org/codelist/ns/</xsl:text><xsl:text>genericode/1.0/}CodeList as the document element of "</xsl:text><xsl:value-of select="document-uri(/)"/><xsl:text>", but found the document element: </xsl:text><xsl:value-of select="concat('{',namespace-uri(/*),'}',local-name(/*))"/><xsl:text>
</xsl:text></xsl:when><xsl:otherwise><xsl:variable name="abie-models" as="element()*"><xsl:for-each-group group-by="gu:I154898269(.,'ModelName')" select="/*/SimpleCodeList/Row[gu:I154898269(.,'ComponentType')='ABIE']"><model name="{current-grouping-key()}" abie-count="{count(current-group())}"/></xsl:for-each-group></xsl:variable><xsl:if test="count($abie-models[@abie-count&gt;1])&gt;1"><xsl:text>Found in the genericode input too many common </xsl:text><xsl:text>library models with multiple ABIE constructs: </xsl:text><xsl:value-of select="$abie-models[@abie-count&gt;1]" separator=","/><xsl:text>
</xsl:text></xsl:if></xsl:otherwise></xsl:choose></xsl:for-each><xsl:call-template name="gu:O18011426"/><xsl:for-each select="$gu:I86054593, $gu:I64540945"><xsl:choose><xsl:when test="not(/configuration)"><xsl:text>Expected {}configuration as the document element of </xsl:text><xsl:text>the configuration file, but in "</xsl:text><xsl:value-of select="document-uri(/)"/><xsl:text>" found the document element: </xsl:text><xsl:value-of select="concat('{',namespace-uri(/*),'}',local-name(/*))"/><xsl:text>
</xsl:text></xsl:when><xsl:otherwise><xsl:if test="not(normalize-space(/*/@version))"><xsl:text>A version of the suite of schemas must be specified </xsl:text><xsl:text>using version= on the configuration file document element.
</xsl:text></xsl:if><xsl:for-each select="//copyright"><xsl:if test="not(@position=('start','end'))"><xsl:text>Every copyright statement must have </xsl:text><xsl:text>position="start" or position="end": </xsl:text><xsl:value-of select="gu:O70408304(.)"/><xsl:text>
</xsl:text></xsl:if></xsl:for-each><xsl:for-each select="//(file|files)"><xsl:choose><xsl:when test="@type='CVA' and not(normalize-space(@name)) and not(normalize-space(@skeleton))"><xsl:text>Each of type= and name= and skeleton= must be </xsl:text><xsl:text>specified: </xsl:text><xsl:value-of select="gu:O70408304(.)"/><xsl:text>
</xsl:text></xsl:when><xsl:when test="not(normalize-space(@type)) or not(normalize-space(@name)) or (@type != 'CVA' and not(normalize-space(@namespace)))"><xsl:text>Each of type=, name= and namespace= must be </xsl:text><xsl:text>specified: </xsl:text><xsl:value-of select="gu:O70408304(.)"/><xsl:text>
</xsl:text></xsl:when><xsl:when test="not(@type=('CABIE','CBBIE','QDT','UDT','EXT','DABIE', 'CVA','XABIE','AABIE','SABIE','SBBIE'))"><xsl:text>Invalid type attribute: </xsl:text><xsl:value-of select="gu:O70408304(.)"/><xsl:text>
</xsl:text></xsl:when><xsl:when test="@abie and (not(self::file) or not(@type=('DABIE','AABIE','XABIE')))"><xsl:text>abie= can only be specified for a single </xsl:text><xsl:text>file with type 'DABIE', 'XABIE' or 'AABIE': </xsl:text><xsl:value-of select="gu:O70408304(.)"/><xsl:text>
    </xsl:text></xsl:when><xsl:when test="@type=('DABIE','AABIE','XABIE') and count($gu:I48405709)=0"><xsl:text>No document-level ABIEs supplied to satisfy type='</xsl:text><xsl:value-of select="@type"/><xsl:text>': </xsl:text><xsl:value-of select="gu:O70408304(.)"/><xsl:text>
</xsl:text></xsl:when><xsl:when test="self::files and not(@type=( 'DABIE','XABIE','AABIE'))"><xsl:text>&lt;files&gt; must have a type of DABIE, XABIE or AABIE': </xsl:text><xsl:value-of select="gu:O70408304(.)"/><xsl:text>
</xsl:text></xsl:when></xsl:choose><xsl:if test="@type='CVA'"><xsl:variable name="skeleton" select="document(@skeleton-uri)"/><xsl:if test="not($skeleton)"><xsl:text>Unable to open specified input CVA skeleton file "</xsl:text><xsl:value-of select="@skeleton-uri"/><xsl:text>" relative to configuration file: </xsl:text><xsl:value-of select="base-uri(@skeleton-uri)"/><xsl:text>
</xsl:text></xsl:if><xsl:for-each select="$skeleton"><xsl:if test="local-name(/*) != 'ContextValueAssociation' or namespace-uri(/*) != 'http://docs.oasis-open.org/codelist/ns/ContextValueAssociation/1.0/'"><xsl:text>Expected {http://docs.oasis-open.org/codelist/ns/</xsl:text><xsl:text>ContextValueAssociation/1.0/}ContextValueAssociation</xsl:text><xsl:text> as the document element of </xsl:text><xsl:text>the input file "</xsl:text><xsl:value-of select="document-uri(/)"/><xsl:text>", but found the document element: </xsl:text><xsl:value-of select="concat('{',namespace-uri(/*),'}',local-name(/*))"/><xsl:text>
</xsl:text></xsl:if></xsl:for-each></xsl:if></xsl:for-each></xsl:otherwise></xsl:choose></xsl:for-each></xsl:template><xsl:template name="gu:I11734717"><xsl:param name="section" as="xsd:string+"/><xsl:param name="runtime" tunnel="yes" as="xsd:boolean"/><xsl:if test="not($runtime)"><xsl:text>
   </xsl:text><xsl:for-each select="$section"><xsl:comment> ===== <xsl:value-of select="."/> ===== </xsl:comment><xsl:text>
   </xsl:text></xsl:for-each></xsl:if></xsl:template><xsl:function name="gu:I11915251" as="xsd:boolean"><xsl:param name="thisBIE" as="element(SimpleValue)"/><xsl:variable name="row" select="$thisBIE/../.."/><xsl:choose><xsl:when test="gu:I154898269($row,'ComponentType')='BBIE'"><xsl:sequence select="boolean($gu:O387245672/key('gu:O14342432','BBIE',.) [gu:I154898269(.,$gu:I258163781)=$thisBIE])"/></xsl:when><xsl:when test="gu:I154898269($row,'ComponentType')='ASBIE'"><xsl:sequence select="boolean($gu:O387245672/key('gu:O14342432','ASBIE',.) [gu:I154898269(.,$gu:I258163781)=$thisBIE])"/></xsl:when><xsl:otherwise><xsl:sequence select="boolean($gu:O387245672/key('gu:O14342432','ABIE',.) [gu:I154898269(.,'ModelName')=$gu:O51632756] [gu:I154898269(.,$gu:I258163781)=$thisBIE])"/></xsl:otherwise></xsl:choose></xsl:function></xsl:stylesheet>