<?xml version="1.0" encoding="UTF-8"?>
<!--
Crane-checkgc4ublndr-obfuscated.xsl

This is a stylesheet to analyze the genericode representation of a UBL NDR 3.0
CCTS model, reporting on inconsistencies or invalidly-expressed values. The
version of NDR implemented by these stylesheets is found at:

  http://docs.oasis-open.org/ubl/UBL-NDR/v3.0/UBL-NDR-v3.0.html
  
Note that only the COMxx and MODxx rules that are programmatically tested are
tested by this stylesheet, as those rules are for the CCTS model.  This
stylesheet does not test any generated schemas for conformance to the NDR,
a genericode-expressed CCTS model.

When two models are supplied as arguments the stylesheet creates reports of
the differences between the two, including an analysis of non-backward-
compatible changes.  The difference reports can be exported as DocBook tables.

Please see "CreatingExtensionsWithUBLNDR.html" for an illustration of using
these stylesheets

Copyright (C) - Crane Softwrights Ltd. 
              - http://www.CraneSoftwrights.com/links/training-gctk.htm

Portions copyright (C) - OASIS Open 2015. All Rights Reserved.
                       - http://www.oasis-open.org/who/intellectualproperty.php

This documentation and the URI resolution of the XSLT processor both presume
the use of the free Saxon9HE XSLT processor from http://saxon.sf.net ... if
that XSLT 2.0 processor is not being used, then the results may not be as
expected.

Typical invocation (HTML output to standard output):

  java -jar saxon9he.jar {arguments}

Mandatory Invocation arguments (URI's are relative to the input):

 - stylesheet file:            -xsl:Crane-checkgc4ublndr-obfuscated.xsl
 - input new genericode file   -s:{filename}
 - output HTML file            -o:filename
 - document title suffix       "title-suffix={string}"
 - change column title suffix  "change-suffix={string}"
 - configuration details*      +config={filename} or config-uri={filename}

Optional invocation arguments (URI's are relative to the input):

 - old genericode file         +old={filename} or old-uri={filename}
   (to specify an older version of the model to analyze a comparison)
 - base genericode file        +base={filename} or base-uri={filename}
   (to specify a base library for use by extension components)

Optional invocation arguments (URI's are relative to the output):

 - output DocBook file URI common    docbook-common-uri=file://{filename}
 - output DocBook file URI maindoc   docbook-maindoc-uri=file://{filename}

THE AUTHOR MAKES NO REPRESENTATION ABOUT THE SUITABILITY OF THIS CODE FOR ANY
PURPOSE. THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN 
NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

TECHNICAL NOTE:

This stylesheet has been purposely obfuscated and all comments have been
removed.  Please respect our copyright and do not attempt to reverse 
engineer the techniques involved.

* Input file description

Configuration details file:

 - this is the same configuration file that is input to the Crane-gc2ublndr
   stylesheet that creates the schemas from the CCTS model

(For those readers who are curious, the latest NDR document is dated after the
UBL 2.1 schemas were published and so there are a number of errors reported for
UBL 2.1 that will be repaired in future versions)
Crane-gcublndrcheck.xsl $Id: Crane-checkgc4ublndr.xsl,v 1.28 2015/05/26 16:13:31 admin Exp $
checkgc4ublndr-model.xsl $Id: checkgc4ublndr-model.xsl,v 1.29 2015/05/26 02:01:05 admin Exp $
checkgc4ublndr-report.xsl $Id: checkgc4ublndr-report.xsl,v 1.23 2015/05/26 01:56:08 admin Exp $
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.CraneSoftwrights.com/ns/xslstyle" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:c="urn:X-Crane" exclude-result-prefixes="xs xsd c" version="2.0"><xsl:variable name="c:I1595975995" as="element(allow)*"><allow old="0"><allowed>0..1</allowed><allowed>0..n</allowed></allow><allow old="0..1"><allowed>0..1</allowed><allowed>0..n</allowed></allow><allow old="0..n"><allowed>0..n</allowed></allow><allow old="1"><allowed>0..1</allowed><allowed>0..n</allowed><allowed>1</allowed><allowed>1..n</allowed></allow><allow old="1..n"><allowed>1..n</allowed><allowed>0..n</allowed></allow></xsl:variable><xsl:variable name="c:I797987997" as="xsd:string*" select="'ObjectClassQualifier', 'ObjectClass', 'AssociatedObjectClassQualifier', 'AssociatedObjectClass', 'PropertyTermQualifier', 'PropertyTermPossessiveNoun', 'PropertyTermPrimaryNoun', 'RepresentationTerm', 'DataTypeQualifier'"/><xsl:variable name="c:O531991998" as="xsd:string*" select="$c:I797987997,$c:O398993998, 'DictionaryEntryName'"/><xsl:variable name="c:I319195199" as="attribute()*" select="$config/*/abbreviations/abbreviation[not(@valuesOnly)]/@short"/><xsl:function name="c:I265995999" as="xsd:string?"><xsl:param name="value" as="xsd:string?"/><xsl:sequence select="translate(normalize-space($value),' ','')"/></xsl:function><xsl:key name="c:O227996570" match="abbreviation" use="."/><xsl:function name="c:O227996570" as="xsd:string?"><xsl:param name="c:I199496999" as="xsd:string?"/><xsl:sequence select="(key('c:O227996570',$c:I199496999,$config)/@short,c:I265995999($c:I199496999))[1]"/></xsl:function><xsl:variable name="c:O177330666" as="element()*" select="$config/*/equivalences/equivalence"/><xsl:function name="c:I132997999" as="xsd:boolean"><xsl:param name="c:I159597599" as="xsd:string?"/><xsl:param name="c:O145088726" as="xsd:string?"/><xsl:sequence select="( $c:I159597599 = $c:O145088726 ) or exists($c:O177330666 [$c:I159597599 = primary-noun and $c:O145088726 = representation-term])"/></xsl:function><xsl:variable name="c:O122767384" as="element(c:I113998285)*"><xsl:for-each select="$old//Row"><xsl:variable name="c:I106398399" select="c:I99748499(.,'ObjectClass')"/><xsl:variable name="c:O93880940" select="concat( c:I99748499(.,'ObjectClass'),' ', c:I99748499(.,$c:O398993998),' ', c:I99748499(.,'ComponentType'))"/><xsl:variable name="c:I88665333" select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:O83998736" select="key('c:I79798799',$c:O93880940,$new) [c:I99748499(.,'ObjectClass')=$c:I106398399]/ c:I99748499(.,'DictionaryEntryName')"/><xsl:if test="not(key('c:O75998856',$c:I88665333,$new)) and exists($c:O83998736)"><c:I113998285 c:I53199199="{$c:I88665333}" c:I10856979="c:O122767384" c:I12090727="{$c:O83998736}"/></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:I72544363" as="element(c:I113998285)*"><xsl:for-each select="$old//Row[c:I99748499(.,'DataTypeQualifier')]"><xsl:variable name="c:I88665333" select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:O69390260" select="concat(c:I99748499(.,'ObjectClass'),' ', c:I99748499(.,$c:O398993998),' ', c:I99748499(.,'ComponentType'))"/><xsl:variable name="c:I66498999" select="c:I99748499(.,'DataTypeQualifier')"/><xsl:variable name="c:I63839039" select="key('c:I79798799',$c:O69390260,$new)"/><xsl:if test="exists($c:I63839039) and not($c:I63839039/c:I99748499(.,'DataTypeQualifier')=$c:I66498999)"><c:I113998285 c:I53199199="{$c:I88665333}" old="{$c:I66498999}" c:I10856979="c:I72544363" new="{key('c:O75998856',$c:I88665333,$new)/                  c:I99748499(.,'DataTypeQualifier')}"/></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:O61383692" as="element(c:I113998285)*"><xsl:variable name="c:I66498999" select="distinct-values($old//Row/c:I99748499(.,'DataTypeQualifier'))"/><xsl:for-each select="$new//Row[c:I99748499(.,'DataTypeQualifier')]"><xsl:variable name="c:O83998736" select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:O59110222" select="c:I99748499(.,'DataTypeQualifier')"/><xsl:if test="not($c:O59110222 = $c:I66498999)"><c:I113998285 c:I53199199="{$c:O83998736}" new="{$c:O59110222}" c:I10856979="c:O61383692"/></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:O56999142" as="element(c:I55033655)*"><xsl:for-each select="$old//Row[c:I99748499(.,'Cardinality')]"><xsl:variable name="c:I53199199" select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:O69390260" select="concat(c:I99748499(.,'ObjectClass'),' ', c:I99748499(.,$c:O398993998),' ', c:I99748499(.,'ComponentType'))"/><xsl:variable name="c:O51483096" select="c:I99748499(.,'Cardinality')"/><xsl:variable name="c:I63839039" select="key('c:I79798799',$c:O69390260,$new)"/><xsl:variable name="c:I49874249" select="$c:I63839039/c:I99748499(.,'Cardinality')"/><xsl:if test="exists( $c:I63839039 ) and not($c:I49874249= $c:I1595975995[@old=$c:O51483096]/allowed)"><c:I55033655 c:I53199199="{$c:I53199199}" old="{$c:O51483096}" c:I10856979="c:O56999142" new="{$c:I49874249}"/></xsl:if></xsl:for-each><xsl:for-each select="$old//Row[c:I99748499(.,'ComponentType')='ABIE']"><xsl:variable name="c:I106398399" select="c:I99748499(.,'ObjectClass')"/><xsl:variable name="c:O48362908" select="key('c:O46940470',$c:I106398399,$old)"/><xsl:variable name="c:O45599314" select="key('c:O46940470',$c:I106398399,$new)"/><xsl:variable name="c:O44332666" select="$c:O48362908/c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:O43134486" select="$c:O48362908/c:I99748499(.,$c:O398993998)"/><xsl:for-each select="$c:O45599314 [not(c:I99748499(.,$c:O398993998) = $c:O43134486)]"><xsl:variable name="c:I49874249" select="c:I99748499(.,'Cardinality')"/><xsl:if test="not($c:I49874249=$c:I1595975995[@old='0']/allowed)"><c:I55033655 c:I53199199="{c:I99748499(.,'DictionaryEntryName')}" c:I10856979="c:O56999142" old="0" new="{$c:I49874249}"/></xsl:if></xsl:for-each></xsl:for-each></xsl:variable><xsl:variable name="c:O41999368" as="element(c:I55033655)*"><xsl:for-each select="$old//Row[c:I99748499(.,'ComponentType')='ABIE']"><xsl:variable name="c:I106398399" select="c:I99748499(.,'ObjectClass')"/><xsl:if test="exists(key('c:O46940470',$c:I106398399,$new))"><xsl:variable name="c:I40922461" select="key('c:O46940470',$c:I106398399,$old)/ c:I99748499(.,$c:O398993998)"/><xsl:variable name="c:I39899399" as="document-node()"><xsl:document><xsl:for-each select="$c:I40922461"><element name="{.}"/></xsl:for-each></xsl:document></xsl:variable><xsl:variable name="c:I38926243" as="document-node()"><xsl:document><xsl:for-each select="key('c:O46940470',$c:I106398399,$new)/ c:I99748499(.,$c:O398993998) [.=$c:I40922461]"><element name="{.}"/></xsl:for-each></xsl:document></xsl:variable><xsl:if test="not( deep-equal( $c:I39899399, $c:I38926243 ) )"><c:I55033655 class="{$c:I106398399}" c:I10856979="c:O41999368"><old><xsl:copy-of select="$c:I39899399/*[position()&gt;1]"/></old><new><xsl:copy-of select="$c:I38926243/*[position()&gt;1]"/></new><new-unfiltered><xsl:for-each select="key('c:O46940470',$c:I106398399,$new) [position()&gt;1]"><element name="{c:I99748499(.,$c:O398993998)}" c:I53199199="{c:I99748499(.,'DictionaryEntryName')}"/></xsl:for-each></new-unfiltered></c:I55033655></xsl:if></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:O37999428" as="element(ABIE)*"><xsl:for-each-group select="$old//Row" group-starting-with="*[c:I99748499(.,'ComponentType')='ABIE']"><ABIE name="{c:I99748499(.,$c:O398993998)}" c:I53199199="{c:I99748499(.,'DictionaryEntryName')}" class="{c:I99748499(.,'ObjectClass')}"><xsl:for-each select="current-group()[position()&gt;1]"><xsl:element name="{c:I99748499(.,'ComponentType')}"><xsl:attribute name="name" select="c:I99748499(.,$c:O398993998)"/><xsl:attribute name="cardinality" select="c:I99748499(.,'Cardinality')"/><xsl:attribute name="den" select="c:I99748499(.,'DictionaryEntryName')"/><xsl:for-each select="c:I99748499(.,'AssociatedObjectClass')"><xsl:attribute name="associatedObjectClass" select="."/></xsl:for-each></xsl:element></xsl:for-each></ABIE></xsl:for-each-group></xsl:variable><xsl:variable name="c:O37115720" as="element(ABIE)*"><xsl:for-each-group select="$new//Row" group-starting-with="*[c:I99748499(.,'ComponentType')='ABIE']"><ABIE name="{c:I99748499(.,$c:O398993998)}" c:I53199199="{c:I99748499(.,'DictionaryEntryName')}" class="{c:I99748499(.,'ObjectClass')}"><xsl:for-each select="current-group()[position()&gt;1]"><xsl:element name="{c:I99748499(.,'ComponentType')}"><xsl:attribute name="name" select="c:I99748499(.,$c:O398993998)"/><xsl:attribute name="cardinality" select="c:I99748499(.,'Cardinality')"/><xsl:attribute name="den" select="c:I99748499(.,'DictionaryEntryName')"/><xsl:for-each select="c:I99748499(.,'AssociatedObjectClass')"><xsl:attribute name="associatedObjectClass" select="."/></xsl:for-each></xsl:element></xsl:for-each></ABIE></xsl:for-each-group></xsl:variable><xsl:variable name="c:I36272181" as="element(ABIE)*"><xsl:for-each select="$c:O37115720/*"><xsl:variable name="c:I35466133" select="$c:O37999428/key('c:O34695130',@name,$old)"/><xsl:if test="$c:I35466133"><xsl:copy><xsl:copy-of select="@*"/><xsl:for-each select="*"><xsl:if test="starts-with(@cardinality,'1') or $c:I35466133/*[@name=current()/@name]"><xsl:copy-of select="."/></xsl:if></xsl:for-each></xsl:copy></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:O33956936" as="element(c:I55033655)*"><xsl:for-each select="$c:O37999428/*"><xsl:variable name="c:I35466133" select="."/><xsl:variable name="c:I33249499" select="$c:O37115720/key('c:O34695130',@name,$new)"/><xsl:variable name="c:O32570938" select="$c:I36272181/key('c:O34695130',@name,$new)"/><xsl:variable name="c:I31919519" as="xsd:string?"><xsl:value-of><xsl:for-each select="*"><xsl:variable name="c:O31293646" select="$c:O32570938/*[@name=current()/@name]"/><xsl:if test="position() != count( $c:O31293646/preceding-sibling::* )+1">
          bad position
        </xsl:if><xsl:if test="not( $c:O31293646/@cardinality = $c:I1595975995[@old=current()/@cardinality]/allowed )">
          bad cardinality
        </xsl:if></xsl:for-each></xsl:value-of></xsl:variable><xsl:if test="$c:I31919519"><c:I55033655 c:I10856979="c:O33956936"><xsl:copy-of select="$c:I35466133,$c:I33249499,$c:O32570938"/></c:I55033655></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:O30691846" as="element(SimpleValue)*"><xsl:for-each-group group-by="." select="$new/*/SimpleCodeList/Row/c:I99748499(., 'ModelName')"><xsl:sequence select="."/></xsl:for-each-group></xsl:variable><xsl:variable name="c:O30112754" as="element(c:I113998285)*"><xsl:for-each select="$c:O30691846[not(contains(.,$c:I29555111))]"><xsl:variable name="c:I53199199" select="c:I99748499(../..,'DictionaryEntryName')"/><c:I113998285 c:O11910268="{.}" c:I53199199="{$c:I53199199}" c:I10856979="c:I29017745" c:I11999819="{empty(key('c:O75998856',$c:I53199199,$new))}"/></xsl:for-each></xsl:variable><xsl:variable name="c:I28499571" as="element(c:I113998285)*"><xsl:for-each select="$c:O30691846[contains(.,$c:I29555111)]"><c:I113998285 c:O11910268="{.}" c:I10856979="c:O27999578" c:O11822044="{count(key('c:I27516827','ABIE',$new)                                    [c:I99748499(.,'ModelName')=current()])}"/></xsl:for-each></xsl:variable><xsl:variable name="c:O27050440" as="element(c:I55033655)*"><xsl:variable name="c:I26599599" select="$c:O30691846[contains(.,$c:I29555111)]"/><xsl:for-each select="key('c:I27516827','ABIE',$new) [c:I99748499(.,'ModelName')=$c:I26599599] [position()&gt;1]"><xsl:if test="preceding-sibling::Row[c:I99748499(.,'ComponentType')='ABIE'][1]/ c:I99748499(.,'ObjectClass') &gt; c:I99748499(.,'ObjectClass')"><c:I55033655 c:I53199199="{c:I99748499(.,'DictionaryEntryName')}" c:I10856979="c:O26163540" c:I11735117="{c:I99748499(.,'ObjectClass')}"/></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:O25741548" as="element()*" select="$new/*/SimpleCodeList/Row/Value/*"/><xsl:variable name="c:O25332952" as="element(c:I55033655)*"><xsl:for-each select="$c:O25741548"><xsl:if test="count(*)&gt;0 or normalize-space(.)=''"><c:I55033655 c:I53199199="{c:I99748499(../..,'DictionaryEntryName')}" c:I10856979="c:O24937124" c:I11649459="{../@ColumnRef}"/></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:O24553476" as="element(c:I55033655)*"><xsl:for-each select="$c:O25741548"><xsl:if test="matches(.,'([&lt;&gt;&amp;]|--)')"><c:I55033655 c:I53199199="{c:I99748499(../..,'DictionaryEntryName')}" c:I10856979="c:O24181454" c:I11649459="{../@ColumnRef}" c:I199496999="{.}"/></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:I23820537" as="element(c:I55033655)*"><xsl:for-each select="$c:O25741548[../@ColumnRef=$c:O531991998]"><xsl:variable name="c:I199496999" select="."/><xsl:for-each select="tokenize(replace(.,'([a-z])([A-Z])','$1 $2'), '[^/w/d]+')"><xsl:if test="matches(.,'([A-Z][A-Z])|([a-zA-Z]\d)|(\d[a-zA-Z])') and not(. = $c:I319195199)"><c:I55033655 c:I53199199="{c:I99748499($c:I199496999/../..,'DictionaryEntryName')}" c:I10856979="c:I23470235" c:I11649459="{$c:I199496999/../@ColumnRef}" c:I199496999="{$c:I199496999}"/></xsl:if></xsl:for-each></xsl:for-each></xsl:variable><xsl:variable name="c:O23130086" as="attribute()*" select="$config/*/abbreviations/abbreviation[not(@namesOnly)]/@short"/><xsl:variable name="c:I22799657" as="element(c:I55033655)*"><xsl:for-each select="$c:O25741548[not(../@ColumnRef=$c:O531991998)]"><xsl:variable name="c:I199496999" select="."/><xsl:for-each select="tokenize(.,'[^/w/d]+')"><xsl:if test="matches(.,'([A-Z][A-Z])|([a-zA-Z]\d)|(\d[a-zA-Z])') and not(. = $c:O23130086)"><c:I55033655 c:I53199199="{c:I99748499($c:I199496999/../..,'DictionaryEntryName')}" c:I10856979="c:I22478535" c:I11649459="{$c:I199496999/../@ColumnRef}" c:I199496999="{$c:I199496999}"/></xsl:if></xsl:for-each></xsl:for-each></xsl:variable><xsl:variable name="c:I22166333" as="element(c:I55033655)*"><xsl:for-each select="$c:O25741548[../@ColumnRef=$c:I797987997]"><xsl:if test="contains(.,'.') or contains(.,'_') or normalize-space(.) != ."><c:I55033655 c:I53199199="{c:I99748499(../..,'DictionaryEntryName')}" c:I10856979="c:O21862684" c:I11649459="{../@ColumnRef}" c:I199496999="{.}"/></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:I21567243" as="element(c:I55033655)*"><xsl:for-each select="$c:O25741548[../@ColumnRef=$c:I797987997]"><xsl:variable name="c:I199496999" select="."/><xsl:for-each select="tokenize(.,'[^\w\d]+')"><xsl:if test="( upper-case(substring(.,1,1))!=substring(.,1,1) or lower-case(substring(.,2))!=substring(.,2) ) and not(. = $c:O23130086)"><c:I55033655 c:I53199199="{c:I99748499($c:I199496999/../..,'DictionaryEntryName')}" c:I10856979="c:I21279679" c:I11649459="{$c:I199496999/../@ColumnRef}" c:I199496999="{$c:I199496999}"/></xsl:if></xsl:for-each></xsl:for-each></xsl:variable><xsl:variable name="c:O20999684" as="element(c:I55033655)*"><xsl:for-each select="key('c:I27516827','ABIE',$new)"><xsl:sort select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:I53199199" select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:O20726960" select="c:I99748499(.,$c:O398993998)"/><xsl:variable name="c:O20461230" select="c:I99748499(.,'ObjectClassQualifier')"/><xsl:variable name="c:I20202227" select="c:I99748499(.,'ObjectClass')"/><xsl:variable name="c:I53199199" select="if( $c:I53199199 ) then $c:I53199199 else if( $c:O20726960 ) then $c:O20726960 else '(no DEN or name)'"/><xsl:if test="normalize-space(c:I99748499(.,'Definition'))=''"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="Definition" c:I199496999="(empty)" c:I10856979="c:I19949699"/></xsl:if><xsl:if test="normalize-space($c:I20202227)=''"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="ObjectClass" c:I199496999="(empty)" c:I10856979="c:I19949699"/></xsl:if><xsl:variable name="c:I19703407" select="concat(c:O227996570($c:O20461230),c:O227996570($c:I20202227))"/><xsl:if test="not( c:I99748499(.,$c:O398993998) = $c:I19703407)"><c:I55033655 c:I53199199="{$c:I53199199}" c:I10856979="c:I19949699" c:I11649459="{c:I99748499(.,$c:O398993998)/../@ColumnRef}" c:I199496999="{(c:I99748499(.,$c:O398993998),'(empty)')[1]}" c:I11565043="{$c:I19703407}"/></xsl:if><xsl:variable name="c:I19463121" select="concat( if( $c:O20461230 ) then concat($c:O20461230,'_ ') else '',$c:I20202227,'. Details')"/><xsl:if test="not( $c:I53199199 = $c:I19463121 )"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="DictionaryEntryName" c:I10856979="c:I19949699" c:I199496999="{$c:I53199199}" c:I11565043="{$c:I19463121}"/></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:O19228626" as="element(c:I55033655)*"><xsl:for-each select="key('c:I27516827','BBIE',$new)"><xsl:sort select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:O20726960" select="c:I99748499(.,$c:O398993998)"/><xsl:variable name="c:O18999714" select="c:I99748499(.,'Cardinality')"/><xsl:variable name="c:I53199199" select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:O20461230" select="c:I99748499(.,'ObjectClassQualifier')"/><xsl:variable name="c:I20202227" select="c:I99748499(.,'ObjectClass')"/><xsl:variable name="c:O18776188" select="c:I99748499(.,'PropertyTermQualifier')"/><xsl:variable name="c:O18557860" select="c:I99748499(.,'PropertyTermPossessiveNoun')"/><xsl:variable name="c:I159597599" select="c:I99748499(.,'PropertyTermPrimaryNoun')"/><xsl:variable name="c:I18344551" select="c:I99748499(.,'PropertyTerm')"/><xsl:variable name="c:O18136090" select="c:I99748499(.,'DataType')"/><xsl:variable name="c:O145088726" select="c:I99748499(.,'RepresentationTerm')"/><xsl:variable name="c:O17932314" select="c:I99748499(.,'DataTypeQualifier')"/><xsl:variable name="c:I53199199" select="if( $c:I53199199 ) then $c:I53199199 else if( $c:O20726960 ) then $c:O20726960 else '(no DEN or name)'"/><xsl:if test="not( $c:O18999714=('0..1','1','0..n','1..n') )"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="Cardinality" c:I199496999="&#34;{$c:O18999714}&#34;" c:I10856979="c:O17733066"/></xsl:if><xsl:if test="normalize-space(c:I99748499(.,'Definition'))=''"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="Definition" c:I199496999="(empty)" c:I10856979="c:O17733066"/></xsl:if><xsl:if test="normalize-space($c:I20202227)=''"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="ObjectClass" c:I199496999="(empty)" c:I10856979="c:O17733066"/></xsl:if><xsl:if test="normalize-space($c:I159597599)=''"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="PropertyTermPrimaryNoun" c:I199496999="(empty)" c:I10856979="c:O17733066"/></xsl:if><xsl:if test="not( $c:O145088726 = $config/*/types/type )"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="RepresentationTerm" c:I10856979="c:O17733066" c:I199496999="{$c:O145088726}"/></xsl:if><xsl:variable name="c:I19703407" select="concat(c:O227996570($c:O18776188), c:O227996570($c:O18557860), if( $c:I159597599!='Text' or ( not($c:O18776188) and not($c:O18557860) ) ) then c:O227996570($c:I159597599) else '', if( $c:O145088726!='Text' and not(c:I132997999($c:I159597599,$c:O145088726))) then c:O227996570($c:O145088726) else '' )"/><xsl:if test="not( c:I99748499(.,$c:O398993998) = $c:I19703407)"><c:I55033655 c:I53199199="{$c:I53199199}" c:I10856979="c:O17733066" c:I11649459="{c:I99748499(.,$c:O398993998)/../@ColumnRef}" c:I199496999="{(c:I99748499(.,$c:O398993998),'(empty)')[1]}" c:I11565043="{$c:I19703407}"/></xsl:if><xsl:variable name="c:I19463121" select="concat( $c:O20461230, if( $c:O20461230 ) then '_ ' else '',$c:I20202227,'. ', $c:O18776188, if( $c:O18776188 ) then '_ ' else '',$c:I18344551, if( $c:O18776188 or ( $c:I18344551 != $c:O145088726 ) ) then concat( '. ',$c:O145088726) else '' )"/><xsl:if test="not( $c:I53199199 = $c:I19463121 )"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="DictionaryEntryName" c:I10856979="c:O17733066" c:I199496999="{$c:I53199199}" c:I11565043="{$c:I19463121}"/></xsl:if><xsl:variable name="c:I17538197" select="concat( $c:O18557860, if( $c:O18557860 ) then ' ' else '', $c:I159597599 )"/><xsl:if test="not( $c:I18344551 = $c:I17538197 )"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="PropertyTerm" c:I10856979="c:O17733066" c:I199496999="{$c:I18344551}" c:I11565043="{$c:I17538197}"/></xsl:if><xsl:variable name="c:I17347565" select="concat( $c:O17932314, if( $c:O17932314 ) then '_ ' else '', $c:O145088726, '. Type' )"/><xsl:if test="not( $c:O18136090 = $c:I17347565 )"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="DataType" c:I10856979="c:O17733066" c:I199496999="{$c:O18136090}" c:I11565043="{$c:I17347565}"/></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:O17161032" as="element(c:I55033655)*"><xsl:for-each select="key('c:I27516827','ASBIE',$new)"><xsl:sort select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:O20726960" select="c:I99748499(.,$c:O398993998)"/><xsl:variable name="c:O18999714" select="c:I99748499(.,'Cardinality')"/><xsl:variable name="c:I53199199" select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:O20461230" select="c:I99748499(.,'ObjectClassQualifier')"/><xsl:variable name="c:I20202227" select="c:I99748499(.,'ObjectClass')"/><xsl:variable name="c:O16978468" select="c:I99748499(.,'AssociatedObjectClassQualifier')"/><xsl:variable name="c:I16799747" select="c:I99748499(.,'AssociatedObjectClass')"/><xsl:variable name="c:O18776188" select="c:I99748499(.,'PropertyTermQualifier')"/><xsl:variable name="c:O18557860" select="c:I99748499(.,'PropertyTermPossessiveNoun')"/><xsl:variable name="c:I159597599" select="c:I99748499(.,'PropertyTermPrimaryNoun')"/><xsl:variable name="c:I18344551" select="c:I99748499(.,'PropertyTerm')"/><xsl:variable name="c:O18136090" select="c:I99748499(.,'DataType')"/><xsl:variable name="c:O145088726" select="c:I99748499(.,'RepresentationTerm')"/><xsl:variable name="c:O17932314" select="c:I99748499(.,'DataTypeQualifier')"/><xsl:variable name="c:I53199199" select="if( $c:I53199199 ) then $c:I53199199 else if( $c:O20726960 ) then $c:O20726960 else '(no DEN or name)'"/><xsl:if test="not( $c:O18999714=('0..1','1','0..n','1..n') )"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="Cardinality" c:I199496999="&#34;{$c:O18999714}&#34;" c:I10856979="c:I16624749"/></xsl:if><xsl:if test="normalize-space(c:I99748499(.,'Definition'))=''"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="Definition" c:I199496999="(empty)" c:I10856979="c:I16624749"/></xsl:if><xsl:if test="normalize-space($c:I20202227)=''"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="ObjectClass" c:I199496999="(empty)" c:I10856979="c:I16624749"/></xsl:if><xsl:if test="normalize-space($c:I16799747)=''"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="AssociatedObjectClass" c:I10856979="c:I16624749" c:I199496999="(empty)"/></xsl:if><xsl:if test="not( ( key('c:O46940470',$c:I16799747,$new), key('c:O46940470',$c:I16799747,$base) ) [string(c:I99748499(.,'ObjectClassQualifier')) = string($c:O16978468)] )"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="AssociatedObjectClass" c:I10856979="c:I16624749" c:I199496999="{concat( $c:O16978468, if( $c:O16978468 ) then '_ ' else ' ', $c:I16799747)}"/></xsl:if><xsl:variable name="c:I19703407" select="concat(c:O227996570($c:O18776188),c:O227996570($c:I18344551))"/><xsl:if test="not( c:I99748499(.,$c:O398993998) = $c:I19703407)"><c:I55033655 c:I53199199="{$c:I53199199}" c:I10856979="c:I16624749" c:I11649459="{c:I99748499(.,$c:O398993998)/../@ColumnRef}" c:I199496999="{(c:I99748499(.,$c:O398993998),'(empty)')[1]}" c:I11565043="{$c:I19703407}"/></xsl:if><xsl:variable name="c:I19463121" select="concat( $c:O20461230, if( $c:O20461230 ) then '_ ' else '',$c:I20202227,'. ', $c:O18776188, if( $c:O18776188 ) then '_ ' else '',$c:I18344551, if( $c:O18776188 ) then concat( '. ',$c:O145088726) else '' )"/><xsl:if test="not( $c:I53199199 = $c:I19463121 )"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="DictionaryEntryName" c:I10856979="c:I16624749" c:I199496999="{$c:I53199199}" c:I11565043="{$c:I19463121}"/></xsl:if><xsl:variable name="c:I17538197" select="concat( $c:O16978468, if( $c:O16978468 ) then '_ ' else '', $c:I16799747)"/><xsl:if test="not( $c:I18344551 = $c:I17538197 )"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="PropertyTerm" c:I10856979="c:I16624749" c:I199496999="{$c:I18344551}" c:I11565043="{$c:I17538197}"/></xsl:if><xsl:variable name="c:O16453360" select="$c:I18344551"/><xsl:if test="not( $c:O145088726 = $c:O16453360 )"><c:I55033655 c:I53199199="{$c:I53199199}" c:I11649459="DataType" c:I10856979="c:I16624749" c:I199496999="{$c:O145088726}" c:I11565043="{$c:O16453360}"/></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:I16285469" as="element(c:I55033655)*"><xsl:for-each select="$new/*/SimpleCodeList/Row [not(Value[@ColumnRef='ComponentType']/ SimpleValue=('ABIE','BBIE','ASBIE'))]"><xsl:sort select="c:I99748499(.,'DictionaryEntryName')"/><c:I55033655 c:I53199199="{(c:I99748499(.,'DictionaryEntryName'),                     c:I99748499(.,'ModelName'))[1]}" c:I10856979="c:I19949699/12/13" c:I199496999="{c:I99748499(.,'ComponentType')}"/></xsl:for-each></xsl:variable><xsl:variable name="c:I16120969" as="element(c:I55033655)*"><xsl:for-each select="key('c:I27516827','ABIE',$new)"><xsl:sort select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:I15959759" select="key('c:O46940470',c:I99748499(.,'ObjectClass'),$new)"/><xsl:if test="count($c:I15959759)=0"><c:I55033655 c:I53199199="{c:I99748499(.,'DictionaryEntryName')}" c:I10856979="c:O15801742"/></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:I15646823" as="element(c:I55033655)*"><xsl:for-each-group select="$new/*/SimpleCodeList/Row" group-starting-with="Row[c:I99748499(.,'ComponentType')='ABIE']"><xsl:sort select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:I53199199" select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:O15494912" select="current-group()[c:I99748499(.,'ComponentType')='ASBIE'][1]"/><xsl:variable name="c:I15345923" select="current-group()[c:I99748499(.,'ComponentType')='BBIE'][last()]"/><xsl:if test="$c:I15345923 &gt;&gt; $c:O15494912"><c:I55033655 c:I53199199="{$c:I53199199}" c:I10856979="c:I15199771"/></xsl:if></xsl:for-each-group></xsl:variable><xsl:variable name="c:I15056377" as="element(c:I55033655)*"><xsl:for-each-group select="$new/*/SimpleCodeList/Row" group-starting-with="Row[c:I99748499(.,'ComponentType')='ABIE']"><xsl:sort select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:I53199199" select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:I14915663" select="string(c:I99748499(.,'ObjectClassQualifier'))"/><xsl:variable name="c:I14777555" select="string(c:I99748499(.,'ObjectClass'))"/><xsl:if test="not( every $c:I14641981 in current-group() satisfies ($c:I14915663=string(c:I99748499($c:I14641981,'ObjectClassQualifier')) and ($c:I14777555=string(c:I99748499($c:I14641981,'ObjectClass')))) )"><c:I55033655 c:I53199199="{$c:I53199199}" c:I10856979="c:O14508872"/></xsl:if></xsl:for-each-group></xsl:variable><xsl:variable name="c:O14378162" as="element(c:I55033655)*"><xsl:for-each select="$new/*/SimpleCodeList/Row[c:I99748499(.,'DictionaryEntryName')]"><xsl:sort select="c:I99748499(.,'DictionaryEntryName')"/><xsl:variable name="c:I53199199" select="c:I99748499(.,'DictionaryEntryName')"/><xsl:if test="count(key('c:O75998856',$c:I53199199,$new))&gt;1"><c:I55033655 c:I53199199="{$c:I53199199}" c:I10856979="c:I14249785"/></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:I14123681" as="element(c:I55033655)*"><xsl:for-each select="$new//Row[c:I99748499(.,'ObjectClassQualifier')]"><c:I55033655 c:I53199199="{c:I99748499(.,'DictionaryEntryName')}" c:I10856979="c:I14123681"/></xsl:for-each></xsl:variable><xsl:variable name="c:I13999789" as="element(c:I55033655)*"><xsl:for-each select="$new//Row [c:I99748499(.,'AssociatedObjectClassQualifier')]"><c:I55033655 c:I53199199="{c:I99748499(.,'DictionaryEntryName')}" c:I10856979="c:I13999789"/></xsl:for-each></xsl:variable><xsl:variable name="c:O13878052" as="element(c:I55033655)*"><xsl:for-each select="$new//Row[c:I99748499(.,'ComponentType')='ABIE'] [contains(c:I99748499(.,'ModelName'),$c:I29555111)]"><xsl:if test="not(key('c:I13758413', c:I99748499(.,'ObjectClass')))"><c:I55033655 c:I53199199="{c:I99748499(.,'DictionaryEntryName')}" c:I10856979="c:O13640820"/></xsl:if></xsl:for-each></xsl:variable><xsl:variable name="c:O13525220" as="element(property-term)*" select="if( $config ) then $config/*/expected-maindoc-BIEs/property-term else ()"/><xsl:variable name="c:O13411562" as="element(c:I55033655)*"><xsl:if test="$c:O13525220"><xsl:for-each-group select="$new//Row" group-by="c:I99748499(.,'ModelName')"><xsl:if test="not(contains(c:I99748499(.,'ModelName'),$c:I29555111))"><xsl:if test="not(current-group() [c:I99748499(.,'PropertyTerm')=$c:O13525220])"><c:I55033655 c:doctype="{c:I99748499(.,'ModelName')}" c:reason="absent" c:I10856979="c:O13411562" c:I11481841="{string-join($c:O13525220,', ')}" c:I53199199="{c:I99748499(.,'DictionaryEntryName')}" c:I11565043="{$c:O13525220                          [.=c:I99748499(current(),'PropertyTerm')]/@cardinality}"/></xsl:if><xsl:for-each select="current-group() [c:I99748499(.,'PropertyTerm')=$c:O13525220]"><xsl:variable name="c:I13299799" select="."/><xsl:if test="c:I99748499(.,'ComponentType')!= $c:O13525220[.=c:I99748499(current(),'PropertyTerm')]/ @type"><c:I55033655 c:doctype="{c:I99748499(.,'ModelName')}" c:I10856979="c:O13411562" c:I53199199="{c:I99748499(.,'DictionaryEntryName')}" c:I11481841="{c:I99748499(.,'PropertyTerm')}" c:O11318978="{c:I99748499(.,'ComponentType')}" c:I11565043="{$c:O13525220                          [.=c:I99748499(current(),'PropertyTerm')]/@cardinality}"/></xsl:if><xsl:if test="c:I99748499(.,'Cardinality')!= $c:O13525220[.=c:I99748499(current(),'PropertyTerm')]/ @cardinality"><c:I55033655 c:doctype="{c:I99748499(.,'ModelName')}" c:I10856979="c:O13411562" c:I53199199="{c:I99748499(.,'DictionaryEntryName')}" c:I11481841="{c:I99748499(.,'PropertyTerm')}" c:O11399828="{c:I99748499(.,'Cardinality')}" c:I11565043="{$c:O13525220                          [.=c:I99748499(current(),'PropertyTerm')]/@cardinality}"/></xsl:if><xsl:variable name="c:O13189884" select="count(current-group()[. &lt;&lt; $c:I13299799]) + 1"/><xsl:if test="$c:O13189884 != $c:O13525220[.=c:I99748499(current(),'PropertyTerm')]/ @position"><c:I55033655 c:doctype="{c:I99748499(.,'ModelName')}" c:I10856979="c:O13411562" c:I53199199="{c:I99748499(.,'DictionaryEntryName')}" c:I11481841="{c:I99748499(.,'PropertyTerm')}" c:O13189884="{c:I99748499(.,'Cardinality')}" c:I11565043="{$c:O13525220                          [.=c:I99748499(current(),'PropertyTerm')]/@cardinality}"/></xsl:if></xsl:for-each></xsl:if></xsl:for-each-group></xsl:if></xsl:variable><xsl:variable name="c:O13081770" as="element()*" select="$c:O122767384, $c:I72544363, $c:O61383692, $c:O56999142, $c:O41999368, $c:O33956936, $c:O30112754, $c:I28499571, $c:O27050440, $c:O25332952, $c:O24553476, $c:I23820537, $c:I22799657, $c:I22166333, $c:I21567243, $c:O20999684, $c:O19228626, $c:O17161032, $c:I16285469, $c:I16120969, $c:I15646823, $c:I15056377, $c:O14378162, $c:I14123681, $c:I13999789, $c:O13878052, $c:O13411562"/><xsl:function name="c:O12870774" as="node()*"><xsl:param name="c:O12975414" as="xsd:string"/><a target="_blank" href="http://docs.oasis-open.org/ubl/UBL-NDR/v3.0/UBL-NDR-v3.0.html#{        $c:O12975414}"><xsl:value-of select="$c:O12975414"/></a></xsl:function><xsl:function name="c:O12468562" as="node()*"><xsl:param name="c:I12767807" as="item()+"/><xsl:param name="c:O12666476" as="element()*"/><xsl:param name="c:O12566740" as="xsd:string"/><xsl:text>
</xsl:text><span><xsl:for-each select="$c:O12566740"><xsl:attribute name="title" select="normalize-space(.)"/></xsl:for-each><xsl:copy-of select="c:O12870774(substring($c:I12767807,1,5))"/><xsl:value-of select="concat(substring($c:I12767807,6),': ',count($c:O12666476))"/></span><xsl:text>
</xsl:text></xsl:function><xsl:function name="c:I12767807" as="node()*"><xsl:param name="c:I12767807" as="item()+"/><xsl:param name="c:O12666476" as="element()*"/><xsl:param name="c:O12566740" as="xsd:string"/><xsl:text>
</xsl:text><span><xsl:for-each select="$c:O12566740"><xsl:attribute name="title" select="normalize-space(.)"/></xsl:for-each><xsl:value-of select="concat($c:I12767807,': ',count($c:O12666476))"/></span><xsl:text>
</xsl:text></xsl:function><xsl:function name="c:O12371906" as="node()*"><xsl:param name="c:O12371906" as="element()"/><xsl:param name="c:O12566740" as="item()+"/><a name="{generate-id($c:O12371906)}"><xsl:value-of select="$c:O12566740"/><xsl:text>
</xsl:text></a></xsl:function><xsl:variable name="c:O12276738" as="xsd:string"><xsl:text>
</xsl:text></xsl:variable><xsl:template name="c:O12183022"><xsl:if test="not($old is $new)"><h3>Non-fatal backward compatibility observations</h3><pre><xsl:copy-of select="c:I12767807('Renamed old DENs in new model',$c:O122767384, 'Renaming an old DEN with a new value does not impact conformance, as the schema constraints do not change. However, the DEN is meant to be persistent and should only change if it is necessary to correct it. For example, it might have been used as a key for documentation. Accordingly, one should consider preserving old DEN values in such uses, along with the new DEN values, so that old links continue to work.' )"/><xsl:for-each select="$c:O122767384"><xsl:sort select="@c:I53199199"/><xsl:copy-of select="c:O12371906(.,concat(@c:I53199199,': ',@c:I12090727))"/></xsl:for-each><xsl:copy-of select="c:I12767807('Missing old Data Type Qualifications in new model',$c:I72544363, 'It is not fatal to deem an element to change or no longer to have a data type qualification in a newer model, but it is reported here in case it was an oversight.' )"/><xsl:for-each select="$c:I72544363"><xsl:sort select="@name"/><xsl:copy-of select="c:O12371906(.,(concat('&#34;',@c:I53199199,'&#34;'), concat('old=&#34;',@old,'&#34; new=&#34;', @new,'&#34;')))"/></xsl:for-each><xsl:copy-of select="c:I12767807('Added Data Type Qualifications in new model',$c:O61383692, 'It is not fatal to have new data type qualifications. Such are listed here to help with integrity checking by reviewing important changes to the model.')"/><xsl:for-each select="$c:O61383692"><xsl:sort select="@name"/><xsl:copy-of select="c:O12371906(.,(concat('&#34;',@c:I53199199,'&#34;:'), concat('&#34;',@new,'&#34;')))"/></xsl:for-each></pre><h3>Fatal backward compatibility issues</h3><pre><xsl:copy-of select="c:I12767807('Cardinalities found in error',$c:O56999142, 'When changing the cardinality of an old item in a new model, the minimum can be dropped (but not raised) and the maximum can be raised (but not dropped).')"/><xsl:for-each select="$c:O56999142"><xsl:sort select="@c:I53199199"/><xsl:copy-of select="c:O12371906(.,(concat('&#34;',@c:I53199199,'&#34;'), 'old=',@old,'new=',@new))"/></xsl:for-each><xsl:copy-of select="c:I12767807('Sequences found in error (by DEN)',$c:O41999368, 'All items in the old model must be in the same order in the new model.')"/><xsl:for-each select="$c:O41999368"><xsl:sort select="@class"/><xsl:copy-of select="c:O12371906(.,concat('&#34;',@class,'&#34;'))"/><xsl:text>:
  Old order:
</xsl:text><xsl:for-each select="old/*"><xsl:text>  </xsl:text><xsl:choose><xsl:when test="count(preceding-sibling::*)!= count(../../new/*[@name=current()/@name]/ preceding-sibling::*)">*</xsl:when><xsl:otherwise><xsl:text> </xsl:text></xsl:otherwise></xsl:choose><xsl:value-of select="position(),@name"/><xsl:text>
</xsl:text></xsl:for-each><xsl:text>
  New order (not including newly-introduced optional constructs):
</xsl:text><xsl:for-each select="new/*"><xsl:text>  </xsl:text><xsl:choose><xsl:when test="count(preceding-sibling::*)!= count(../../old/*[@name=current()/@name]/ preceding-sibling::*)">*</xsl:when><xsl:otherwise><xsl:text> </xsl:text></xsl:otherwise></xsl:choose><xsl:value-of select="position(),@name"/><xsl:text>
</xsl:text></xsl:for-each><xsl:text>
  New order (all constructs):
</xsl:text><xsl:for-each select="new-unfiltered/*"><xsl:text>  </xsl:text><xsl:choose><xsl:when test="count(preceding-sibling::*)!= count(../../old/*[@name=current()/@name]/ preceding-sibling::*)">*</xsl:when><xsl:otherwise><xsl:text> </xsl:text></xsl:otherwise></xsl:choose><xsl:value-of select="position(),@name"/><xsl:text>
</xsl:text></xsl:for-each></xsl:for-each></pre></xsl:if><h3>Naming and Design Rules (NDR)</h3><p>
    As defined in <a target="_blank" href="http://docs.oasis-open.org/ubl/UBL-NDR/v3.0/UBL-NDR-v3.0.html">the NDR v3.0 specification</a>.
  </p><pre><xsl:copy-of select="c:O12468562('MOD01 - Document ABIEs',$c:O30112754, 'A list of all Document ABIEs in both the old and new models. Those found only in the old model are parenthesized. It is not an error that an old Document ABIE is missing when working only on a subset of Document ABIEs. Even when working with a full set, it should not be the case that old Document ABIEs are abandoned, as this would not be backward compatible.' )"/><xsl:for-each select="$c:O30112754"><xsl:sort select="@c:I53199199"/><xsl:choose><xsl:when test="xsd:boolean(@c:I11999819)"><xsl:copy-of select="c:O12371906(.,concat('(',@c:O11910268,': ',@c:I53199199,')'))"/></xsl:when><xsl:otherwise><xsl:copy-of select="c:O12371906(.,concat(@c:O11910268,': ',@c:I53199199))"/></xsl:otherwise></xsl:choose></xsl:for-each><xsl:copy-of select="c:O12468562('MOD02 - Library collections', $c:I28499571, 'A list of all library collections (should only be one) and the number of ABIEs in the collection. How a library collection is identified is by the model name containing a particular substring, by default ''Current'' but this can be overridden by a model parameter.' )"/><xsl:for-each select="$c:I28499571"><xsl:copy-of select="c:O12371906(.,concat(@c:O11910268, ': ',@c:O11822044,' ABIEs'))"/></xsl:for-each><xsl:copy-of select="c:O12468562('MOD03 - Library items out of order', $c:O27050440, 'The ABIEs in the common library shall be in alphabetical order. The ABIE reported is the one that occurrs before the prior ABIE. Subsequent ones might very well be in order, which would indicate that it is the prior ABIE that is actually the one out of order.' )"/><xsl:for-each select="$c:O27050440"><xsl:copy-of select="c:O12371906(.,@c:I11735117)"/></xsl:for-each><xsl:copy-of select="c:O12468562('COM01 - structured values', $c:O25332952, 'The CCTS values in the model cannot be structured and must be made up of only string values. No empty values are allowed (the CCTS item should be absent from the mdoel if it has no value). The DEN and the column in error are indicated for each problem.' )"/><xsl:for-each select="$c:O25332952"><xsl:copy-of select="c:O12371906(.,concat(@c:I53199199,': ',@c:I11649459))"/></xsl:for-each><xsl:copy-of select="c:O12468562('COM02 - prohibited characters', $c:O24553476, 'The CCTS values in the model cannot have sensitive XML characters or sequences that might disturb down-stream processing of the information.' )"/><xsl:for-each select="$c:O24553476"><xsl:copy-of select="c:O12371906(.,concat(@c:I53199199,': ',@c:I11649459,'=',@c:I199496999))"/></xsl:for-each><xsl:copy-of select="$c:O12276738,c:O12870774('COM03')"/><xsl:text> - list of permitted abbreviations in name values: </xsl:text><xsl:choose><xsl:when test="not($c:I319195199)"><xsl:text>(empty)</xsl:text></xsl:when><xsl:otherwise><xsl:for-each select="$c:I319195199"><xsl:value-of select="$c:O12276738,.,'=',.."/></xsl:for-each></xsl:otherwise></xsl:choose><xsl:copy-of select="c:O12468562('COM03 - prohibited abbreviations in name values', $c:I23820537, 'This analysis considers any word in a name value where the word contains two adjacent capital letters or a letter and a digit to be an abbreviation.' )"/><xsl:for-each select="$c:I23820537"><xsl:copy-of select="c:O12371906(.,concat(@c:I53199199,': ',@c:I11649459,'=',@c:I199496999))"/></xsl:for-each><xsl:copy-of select="$c:O12276738,c:O12870774('COM04')"/><xsl:text> - list of permitted abbreviations in other values: </xsl:text><xsl:choose><xsl:when test="not($c:O23130086)"><xsl:text>(empty)</xsl:text></xsl:when><xsl:otherwise><xsl:for-each select="$c:O23130086"><xsl:value-of select="$c:O12276738,.,'=',.."/></xsl:for-each></xsl:otherwise></xsl:choose><xsl:copy-of select="c:O12468562('COM04 - prohibited abbreviations in non-name values', $c:I22799657, 'This analysis considers any word in a non-name value where the word contains two adjacent capital letters or a letter and a digit to be an abbreviation.' )"/><xsl:for-each select="$c:I22799657"><xsl:copy-of select="c:O12371906(.,concat(@c:I53199199,': ',@c:I11649459,'=',@c:I199496999))"/></xsl:for-each><xsl:copy-of select="$c:O12276738,c:O12870774('COM05')"/><xsl:text> - list of equivalences of primary nouns to representation terms
        in names when testing for duplication: </xsl:text><xsl:choose><xsl:when test="not($c:O177330666)"><xsl:text>(empty)</xsl:text></xsl:when><xsl:otherwise><xsl:for-each select="$c:O177330666"><xsl:value-of select="$c:O12276738,primary-noun,'=',representation-term"/></xsl:for-each></xsl:otherwise></xsl:choose><xsl:copy-of select="$c:O12276738,$c:O12276738,c:O12870774('COM06')"/><xsl:text> - leading name part in attribute names
        (not part of the CCTS model)
</xsl:text><xsl:copy-of select="$c:O12276738,c:O12870774('COM07')"/><xsl:text> - non-leading abbreviations in attribute names 
        (not part of the CCTS model)
</xsl:text><xsl:copy-of select="c:O12468562('COM08 - prohibited characters in name values', $c:I22166333, 'Name values contribute to the Dictionary Entry Name that has its own syntax of spaces, underscore and period. This analysis identifies those values violating the restrictions.' )"/><xsl:for-each select="$c:I22166333"><xsl:copy-of select="c:O12371906(.,concat(@c:I53199199,': ',@c:I11649459,'=',@c:I199496999))"/></xsl:for-each><xsl:copy-of select="$c:O12276738,c:O12870774('COM09')"/><xsl:text> - use of the singular form in names (cannot be tested)
</xsl:text><xsl:copy-of select="c:O12468562('COM10 - prohibited case in name values', $c:I21567243, 'Words in name values must have leading upper-case and the remainder lower-case unless the word is an approved abbreviation.' )"/><xsl:for-each select="$c:I21567243"><xsl:copy-of select="c:O12371906(.,concat(@c:I53199199,': ',@c:I11649459,'=',@c:I199496999))"/></xsl:for-each><xsl:copy-of select="c:O12468562('COM11 - invalid ABIE values', $c:O20999684, 'ABIE values are constrained by the specification.' )"/><xsl:for-each select="$c:O20999684"><xsl:copy-of select="c:O12371906(.,concat(@c:I53199199,': ',@c:I11649459,'=',@c:I199496999, if(@c:I11565043) then concat(' (expected: ',@c:I11565043,')') else ''))"/></xsl:for-each><xsl:copy-of select="c:O12468562('COM12 - invalid BBIE values', $c:O19228626, 'BBIE values are constrained by the specification.' )"/><xsl:for-each select="$c:O19228626"><xsl:copy-of select="c:O12371906(.,concat(@c:I53199199,': ',@c:I11649459,'=',@c:I199496999, if(@c:I11565043) then concat(' (expected: ',@c:I11565043,')') else ''))"/></xsl:for-each><xsl:copy-of select="c:O12468562('COM13 - invalid ASBIE values', $c:O17161032, 'ASBIE values are constrained by the specification.' )"/><xsl:for-each select="$c:O17161032"><xsl:copy-of select="c:O12371906(.,concat(@c:I53199199,': ',@c:I11649459,'=',@c:I199496999, if(@c:I11565043) then concat(' (expected: ',@c:I11565043,')') else ''))"/></xsl:for-each><xsl:copy-of select="c:O12468562('COM11/COM12/COM13 - invalid component type', $c:I16285469, 'Each component must be either an ABIE, an ASBIE or a BBIE.' )"/><xsl:for-each select="$c:I16285469"><xsl:copy-of select="c:O12371906(.,concat(@c:I53199199,': ',@c:I199496999))"/></xsl:for-each><xsl:copy-of select="c:O12468562('COM14 - ABIE composition', $c:I16120969, 'An ABIE cannot be empty.' )"/><xsl:for-each select="$c:I16120969"><xsl:copy-of select="c:O12371906(.,@c:I53199199)"/></xsl:for-each><xsl:copy-of select="c:O12468562('COM15 - ABIE order', $c:I15646823, 'All BBIEs for an ABIE must be before all ASBIEs.' )"/><xsl:for-each select="$c:I15646823"><xsl:copy-of select="c:O12371906(.,@c:I53199199)"/></xsl:for-each><xsl:copy-of select="c:O12468562('COM16 - ABIE organization', $c:I15056377, 'All BIEs for an ABIE must be together with the ABIE.' )"/><xsl:for-each select="$c:I15056377"><xsl:copy-of select="c:O12371906(.,@c:I53199199)"/></xsl:for-each><xsl:copy-of select="c:O12468562('COM17 - DEN duplication', $c:O14378162, 'No two BIEs can have the same DEN' )"/><xsl:for-each select="$c:O14378162"><xsl:copy-of select="c:O12371906(.,@c:I53199199)"/></xsl:for-each></pre><h3>Non-fatal issues but not allowed by UBL's use of NDR</h3><pre><xsl:copy-of select="c:I12767807('Qualified ABIEs',$c:I14123681, 'In UBL there are no qualifications on ABIEs' )"/><xsl:for-each select="$c:I14123681"><xsl:sort select="@name"/><xsl:copy-of select="c:O12371906(.,concat('&#34;',@c:I53199199,'&#34;'))"/></xsl:for-each><xsl:copy-of select="c:I12767807('ASBIEs referring to qualified ABIEs',$c:I13999789, 'In UBL there are no qualifications on ABIEs' )"/><xsl:for-each select="$c:I13999789"><xsl:sort select="@name"/><xsl:copy-of select="c:O12371906(.,concat('&#34;',@c:I53199199,'&#34;'))"/></xsl:for-each><xsl:copy-of select="c:I12767807('Orphaned ABIEs not being referenced by an ASBIE',$c:O13878052, 'Unused library ABIEs are not an error, but having them is suspicious.')"/><xsl:for-each select="$c:O13878052"><xsl:sort select="@name"/><xsl:copy-of select="c:O12371906(.,concat('&#34;',@c:I53199199,'&#34;'))"/></xsl:for-each><xsl:copy-of select="c:I12767807( 'Missing expected BIEs in Document ABIE',$c:O13411562, 'The configuration file indicates the need for certain property terms in all Document ABIEs')"/><xsl:for-each select="$c:O13411562"><xsl:sort select="@doctype"/><xsl:copy-of select="c:O12371906(.,concat(@c:I53199199,': ',@c:I11481841, if( @c:O11399828 ) then concat(' (expected cardinality ''',@c:I11565043, ''',found cardinality ''',@c:O11399828,''')') else if( @c:O11318978 ) then concat(' (expected type ''',@c:I11565043, ''',found type ''',@c:O11318978,''')') else if( @c:O13189884 ) then concat(' (expected position ''',@c:O13189884, ''',found position ''',@c:O13189884,''')') else ' (missing)'))"/></xsl:for-each></pre></xsl:template><xsl:output indent="yes"/><xsl:param name="old" as="document-node()" select="if( $old-uri) then doc(resolve-uri($old-uri,base-uri($new))) else if( $new ) then $new else error( (), 'Missing URI or open old document')"/><xsl:param name="old-uri" as="xsd:string?"/><xsl:param name="new" as="document-node()" select="/"/><xsl:param name="base" as="document-node()?" select="if( $base-uri) then doc(resolve-uri($base-uri,base-uri($new))) else ()"/><xsl:param name="base-uri" as="xsd:string?"/><xsl:param name="config" as="document-node()?" select="if( not($config-uri) ) then () else doc(resolve-uri($config-uri,base-uri($new)))"/><xsl:param name="config-uri" as="xsd:string?"/><xsl:param name="title-suffix" as="xsd:string" required="yes"/><xsl:param name="change-suffix" as="xsd:string" select="''"/><xsl:param name="docbook-common-uri" as="xsd:string?"/><xsl:param name="docbook-maindoc-uri" as="xsd:string?"/><xsl:key name="c:O75998856" match="Row" use="c:I99748499(.,'DictionaryEntryName')"/><xsl:key name="c:I27516827" match="Row" use="c:I99748499(.,'ComponentType')"/><xsl:key name="c:I27516827" match="Row[c:I99748499(.,'DataType')]" use="c:I99748499(.,'DataType')"/><xsl:key name="c:O46940470" match="Row[not(c:I99748499(.,'ComponentType')='ABIE')]" use="c:I99748499(.,'ObjectClass')"/><xsl:key name="c:I79798799" match="Row" use="concat( c:I99748499(.,'ObjectClass'),' ', c:I99748499(.,$c:O398993998),' ', c:I99748499(.,'ComponentType'))"/><xsl:key name="c:I13758413" match="Row" use="Value[@ColumnRef='AssociatedObjectClass']/SimpleValue"/><xsl:key name="c:O34695130" match="ABIE" use="@name"/><xsl:key name="c:I11239267" match="ABIE" use="@class"/><xsl:key name="c:I11160671" match="BBIE|ASBIE" use="../@name"/><xsl:variable name="c:I29555111" as="xsd:string" select="($config/*/@commonModelSubstring,'Common')[1]"/><xsl:function name="c:I99748499" as="element()*"><xsl:param name="row" as="element(Row)"/><xsl:param name="cols" as="item()+"/><xsl:sequence select="$row/Value [ @ColumnRef=(for $each in $cols return string($each)) ]/*"/></xsl:function><xsl:variable name="c:O398993998" as="xsd:string+" select="('UBLName','ComponentName')"/><xsl:template match="/"><xsl:if test="not($config)"><xsl:message terminate="yes"><xsl:text>Either +config= or config-uri= is required</xsl:text><xsl:text> as a parameter pointing to the configuration file.</xsl:text></xsl:message></xsl:if><xsl:variable name="docbook-common"><xsl:call-template name="c:O11083166"><xsl:with-param name="common" select="true()"/></xsl:call-template></xsl:variable><xsl:variable name="docbook-maindoc"><xsl:call-template name="c:O11083166"><xsl:with-param name="common" select="false()"/></xsl:call-template></xsl:variable><xsl:result-document method="html"><html><head><title>Analysis of <xsl:value-of select="$title-suffix"/></title></head><body><xsl:if test="$c:O13081770[self::c:bad]"><h2>Errors detected</h2><p>The following DENs need attention<xsl:text/><xsl:if test="($docbook-common,$docbook-maindoc)[.//tbody/row]">
              (<a href="#_analysis">complete analysis here</a>)</xsl:if><xsl:text/>:</p><ul><xsl:for-each-group select="$c:O13081770[self::c:bad]" group-by=".//@c:I53199199"><xsl:sort select="current-grouping-key()"/><li><xsl:value-of select="@c:I53199199"/><xsl:text> - </xsl:text><xsl:copy-of select="c:I11006731(current-group())"/></li></xsl:for-each-group></ul></xsl:if><h2><a name="_analysis"/>Complete analysis</h2><p>
         Hover over the category titles for a more detailed description
         in a pop-up tool-tip.
       </p><xsl:call-template name="c:O12183022"/><xsl:apply-templates select="$docbook-common[.//tbody/row], $docbook-maindoc[.//tbody/row]" mode="c:O10931342"/></body></html></xsl:result-document><xsl:if test="$docbook-common-uri and $docbook-common[.//tbody/row]"><xsl:result-document href="{$docbook-common-uri}"><xsl:copy-of select="$docbook-common"/></xsl:result-document></xsl:if><xsl:if test="$docbook-maindoc-uri and $docbook-maindoc[.//tbody/row]"><xsl:result-document href="{$docbook-maindoc-uri}"><xsl:copy-of select="$docbook-maindoc"/></xsl:result-document></xsl:if></xsl:template><xsl:function name="c:I11006731" as="node()*"><xsl:param name="group" as="element()*"/><xsl:for-each select="$group"><xsl:if test="position()&gt;1">, </xsl:if><xsl:text>(</xsl:text><a href="#{generate-id(.)}"><xsl:if test="false() and @c:I10856979"><xsl:attribute name="title" select="@c:I10856979"/></xsl:if><xsl:value-of select="position()"/></a><xsl:text>)</xsl:text></xsl:for-each></xsl:function><xsl:template name="c:O11083166"><xsl:param name="common" as="xsd:boolean"/><table><title><xsl:text>Changes to </xsl:text><xsl:value-of select="if( $common ) then 'Library' else 'Document'"/><xsl:text> Elements </xsl:text><xsl:value-of select="$title-suffix"/></title><tgroup cols="3"><xsl:comment select="if( $common ) then 'Library' else 'Document', $title-suffix"/><xsl:text>
</xsl:text><colspec colwidth="35*"/><colspec colwidth="35*"/><colspec colwidth="30*"/><thead><row><entry>Aggregate BIE</entry><entry>Basic or Association BIE</entry><entry>Changes for <xsl:value-of select="$change-suffix"/></entry></row></thead><tbody><xsl:call-template name="c:I10783621"><xsl:with-param name="abies" select="key('c:I27516827','ABIE',$new) [contains(c:I99748499(.,'ModelName'),'Common')=$common]"/></xsl:call-template></tbody></tgroup></table></xsl:template><xsl:template name="c:I10783621"><xsl:param name="abies" as="element(Row)*"/><xsl:for-each select="$abies"><xsl:sort select="c:I99748499(.,$c:O398993998)"/><xsl:variable name="abieName" select="c:I99748499(.,$c:O398993998)"/><xsl:variable name="classNameType" select="concat( c:I99748499(.,'ObjectClass'),' ', $abieName,' ', c:I99748499(.,'ComponentType'))"/><xsl:choose><xsl:when test="not(key('c:I79798799',$classNameType,$old))"><xsl:call-template name="c:O10711248"><xsl:with-param name="col1" select="$abieName"/><xsl:with-param name="col3">Added</xsl:with-param></xsl:call-template></xsl:when><xsl:otherwise><xsl:variable name="childrenOld" select="key('c:O46940470', c:I99748499(.,'ObjectClass'), $old)"/><xsl:variable name="childrenNew" select="key('c:O46940470', c:I99748499(.,'ObjectClass'), $new)"/><xsl:variable name="thisABIEchanges" as="element()*"><xsl:for-each select="$childrenNew"><xsl:variable name="newChild" select="."/><xsl:variable name="oldChild" select="$childrenOld[c:I99748499(.,$c:O398993998)= current()/c:I99748499(.,$c:O398993998)]"/><xsl:choose><xsl:when test="not($oldChild)"><xsl:call-template name="c:O10711248"><xsl:with-param name="col2" select="$newChild/c:I99748499(.,$c:O398993998)"/><xsl:with-param name="col3">Added</xsl:with-param></xsl:call-template></xsl:when><xsl:otherwise><xsl:if test="$newChild/c:I99748499(.,'Cardinality')!= $oldChild/c:I99748499(.,'Cardinality')"><xsl:call-template name="c:O10711248"><xsl:with-param name="col2" select="$newChild/c:I99748499(.,$c:O398993998)"/><xsl:with-param name="col3"><xsl:text>Changed cardinality from </xsl:text><xsl:value-of select="$oldChild/c:I99748499(.,'Cardinality')"/><xsl:text> to </xsl:text><xsl:value-of select="$newChild/c:I99748499(.,'Cardinality')"/></xsl:with-param></xsl:call-template></xsl:if><xsl:if test="$newChild/c:I99748499(.,'DictionaryEntryName')!= $oldChild/c:I99748499(.,'DictionaryEntryName')"><xsl:call-template name="c:O10711248"><xsl:with-param name="col2" select="$newChild/c:I99748499(.,$c:O398993998)"/><xsl:with-param name="col3"><xsl:text>Changed dictionary entry name from “</xsl:text><xsl:value-of select="$oldChild/c:I99748499(.,'DictionaryEntryName')"/><xsl:text>” to “</xsl:text><xsl:value-of select="$newChild/c:I99748499(.,'DictionaryEntryName')"/><xsl:text>”</xsl:text></xsl:with-param></xsl:call-template></xsl:if></xsl:otherwise></xsl:choose></xsl:for-each></xsl:variable><xsl:if test="$thisABIEchanges"><xsl:call-template name="c:O10711248"><xsl:with-param name="col1" select="$abieName"/></xsl:call-template><xsl:copy-of select="$thisABIEchanges"/></xsl:if></xsl:otherwise></xsl:choose></xsl:for-each></xsl:template><xsl:template name="c:O10711248"><xsl:param name="col1" select="' '" as="xsd:string?"/><xsl:param name="col2" select="' '" as="xsd:string?"/><xsl:param name="col3" select="' '" as="xsd:string?"/><row><xsl:if test="$col1!=' '"><xsl:processing-instruction name="dbhtml">bgcolor="#DDDDDD"</xsl:processing-instruction><xsl:processing-instruction name="dbfo">bgcolor="#DDDDDD"</xsl:processing-instruction></xsl:if><entry><xsl:value-of select="normalize-space($col1)"/></entry><entry><xsl:value-of select="normalize-space($col2)"/></entry><entry><xsl:value-of select="normalize-space($col3)"/></entry></row></xsl:template><xsl:variable name="c:I10639839" as="element()+"><xlate from="table"/><xlate from="title" to="h2"/><xlate from="tgroup" to="table"><attrs style="border:1px solid black"/></xlate><xlate from="thead"/><xlate from="tbody"/><xlate from="colspec"/><xlate from="row" to="tr"/><xlate from="entry" grandparent="thead" to="th"><attrs style="border:1px solid black"/></xlate><xlate from="entry" grandparent="tbody" to="td"><attrs style="border:1px solid black"/></xlate></xsl:variable><xsl:template match="*" mode="c:O10931342"><xsl:variable name="c:I13299799" select="$c:I10639839[name(current())=@from] [not(@grandparent) or name(current()/parent::*/parent::*)=@grandparent]"/><xsl:choose><xsl:when test="not($c:I13299799)"><xsl:message select="'Not handled:',name(.)"/></xsl:when><xsl:when test="not($c:I13299799/@to)"><xsl:apply-templates mode="c:O10931342"/></xsl:when><xsl:otherwise><xsl:element name="{$c:I13299799/@to}"><xsl:copy-of select="$c:I13299799/attrs/@*"/><xsl:for-each select="processing-instruction()[contains(.,'bgcolor')]"><xsl:attribute name="style" select="concat('background-color:',replace(.,'.*&#34;(.+)&#34;.*','$1'))"/></xsl:for-each><xsl:apply-templates mode="c:O10931342"/></xsl:element></xsl:otherwise></xsl:choose></xsl:template></xsl:stylesheet>